/***************************************************
 * Automatically generated by Maple.
 * Created On: Wed Mar 25 17:09:01 2020.
***************************************************/
#include <stdlib.h>
#include <stdio.h>
#include <string.h>
#include <math.h>

/***************************************************
* Variable Definition for System:

* State variable(s):
*    S.w[ 1] = x[ 0] = `Main.OP2.firstOrder1.y`(t)
*
* Output variable(s):
*    S.w[ 9] = y[ 0] = `Main.OP2.PHI_TM_PNT_OP_W`(t)
*    S.w[ 8] = y[ 1] = `Main.OP2.trq_AT_PNT_Nm1`(t)
*
* Input variable(s):
*    S.w[10] = u[ 0] = `Main.OP2.nu_oil_m2ps`(t)
*    S.w[11] = u[ 1] = `Main.OP2.p_Line_Pa`(t)
*    S.w[12] = u[ 2] = `Main.OP2.w_AT_PNT_radps1`(t)
*
* Parameter(s):
*    S.w[22] = p[ 0] = `Main.OP2.Oil_Viscosity_Breakpoint[2]` (default = .6e-5)
*    S.w[23] = p[ 1] = `Main.OP2.Oil_Viscosity_Breakpoint[3]` (default = .97e-5)
*    S.w[24] = p[ 2] = `Main.OP2.Oil_Viscosity_Breakpoint[4]` (default = .18e-4)
*
* Additional Parameter(s):
*    (vr = 50) ap[ 0] = `Main.OP2.minsamplestep` (default = 1/40)
*    (vr = 51) ap[ 1] = `Main.OP2.binfilename` (default = "DISABLED", type = string)
*
************************************************/

/* No scaling - no nominals */
double *nomfac=NULL;
/* Configurable parameters */
#define MAXERRSTRLENGTH 10000
#define MAXWARNSTRLENGTH 10000
#define WARNNUMDATPTS 100000
#define ERRTOL 1.000000e-06
#define MAXNEVT 0
#define MAXINTSTEP 0
#define EVTITER 100
#define EVTHYST 0.000000e+00
#define FMUHYST 1.000000e-10

#define SSTO 0
/* Wordsize integer definition */
#ifndef M_INT
# if defined _MINGW64 || defined X86_64_WINDOWS
#  define M_INT long long
# elif defined __x86_64__ || defined __ppc64__
#  define M_INT long
# elif defined _M_X64
#  define M_INT long long
# else
#  define M_INT int
# endif
#endif

static int errorOccured = 0;
static char errorString[MAXERRSTRLENGTH+1];
static int warningOccured = 0;
static char warningString[MAXWARNSTRLENGTH+1];

static void SolverError(double t, int term, char *errmsg)
{
	if(term) {
		sprintf(errorString,"Simulation terminated at t=%20.16e: %s\n",t,errmsg);
		errorOccured = 2;
	}
	else {
		sprintf(errorString,"Error at t=%20.16e: %s\n",t,errmsg);
		errorOccured = 1;
	}
}


static void SolverWarning(double t, char *warnmsg)
{
	if(!warningOccured) {
		sprintf(warningString,"Warning at t=%20.16e: %s\n",t,warnmsg);
		warningOccured = 1;
	}
}

/* Fixed parameters */
#define NDIFF 1
#define NDFA 1
#define NEQ 21
#define NPAR 3
#define NINP 3
#define NINPD 0
#define NDISC 9
#define NIX1 11
#define NOUT 2
#define NCON 0
#define NEVT 2

#ifndef max
#define max(a,b) (((a)>(b))?(a):(b))
#endif
#ifndef min
#define min(a,b) (((a)<(b))?(a):(b))
#endif
static double nData[2] = {1.0*NEQ,1.0*NPAR};
static double minsamplestep = 2.50000000000000000e-02;

static void writeErrorToFile(FILE *fptr, char *errstr) {
	char *err, uerr[]="unknown error";
	int i;
	double d;

	if (errstr)
		err = errstr;
	else if (errorOccured)
		err = errorString;
	else
		err = uerr;

	d = -1e10; /*terminate value*/
	fwrite(&d,sizeof(double),1,fptr);
	for(i=0;;i++) {
		d = (double)err[i];
		fwrite(&d,sizeof(double),1,fptr);
		if (!err[i]) break;
	}

	fclose(fptr);
}

static int inputchange=0;

static int pchange=0;
static int pflags[]={0,0,0};

typedef struct {
	double *w;		/* Float workspace */
	M_INT *iw;		/* Integer workspace */
	double *wset;		/* Float workspace */
	double *psto;		/* Float projection workspace */
	double *ssto;		/* Solver storage (implicit) */
} SolverStruct;

#include <string.h>
#include <stdarg.h>

#define MAXSTRINGLENGTH 1000
#define MAXNUMPART 20


void toMapleError(char *msg, ...)
{
	char fcpy[MAXSTRINGLENGTH+1],*offs[MAXNUMPART+1],
		*msg_pars[MAXNUMPART+1],res_str[MAXSTRINGLENGTH+1];
	int argref[MAXNUMPART],maxargref,npart,v,i,j,res_len;
	va_list argptr;

	if(strlen(msg)>MAXSTRINGLENGTH)
		strcpy(fcpy,"message string is too long");
	else
		strcpy(fcpy,msg);

	maxargref=0;
	npart=0;
	i=0;
	offs[npart]=&fcpy[i];
	for(j=0;fcpy[j]!='\0';j++)
		if(fcpy[j]=='%' && fcpy[j+1]!='%') {
			fcpy[j++]='\0';
			if(fcpy[j]=='-') j++;
			if(fcpy[j]=='\0') break;
			v=0;
			while(fcpy[j]>='0' && fcpy[j]<='9') v=10*v+(fcpy[j++]-'0');
			argref[npart]=v;
			if(v>maxargref) maxargref=v;
			i=j;
			npart++;
			offs[npart]=&fcpy[i];
		}

	va_start(argptr,msg);
	for(i=0;i<maxargref;i++) msg_pars[i] = va_arg(argptr, char*);
	va_end(argptr);

	strcpy(res_str,offs[0]);
	res_len=strlen(res_str);
	for(i=0;i<npart;i++) {
		res_len+=strlen(msg_pars[argref[i]-1]);
		if(res_len>MAXSTRINGLENGTH) {
			strcpy(res_str,"message string is too long");
			break;
		}
		else
			strcat(res_str,msg_pars[argref[i]-1]);

		res_len+=strlen(offs[i+1]);
		if(res_len>MAXSTRINGLENGTH) {
			strcpy(res_str,"message string is too long");
			break;
		}
		else
			strcat(res_str,offs[i+1]);
	}
	for(i=0;i<maxargref;i++) free(msg_pars[i]);
	strcpy(errorString,res_str);
	errorOccured = 1;
}

char* toMapleInteger(int i)
{
	char *str=(char *)malloc(21);
	sprintf(str,"%li",(long)i);
	return(str);
}

char* toMapleFloat(double f)
{
	char *str=(char *)malloc(20);
	sprintf(str,"%f",f);
	return(str);
}

char* toMapleString(const char *s)
{
	char *str=(char *)malloc(strlen(s)+1);
	strcpy(str,s);
	return(str);
}

char* toMapleBoolean(int b)
{
	char *str=(char *)malloc(6);
	switch(b) {
	case 0:
		strcpy(str,"false");
	default:
		strcpy(str,"true");
	return(str);
	}
}

void toMapleUserinfo(int level, char *name, char *msg)
{
	sprintf(errorString,"%s[%li]: %s\n",name,(long)level,msg);
	errorOccured = -1;
}

typedef struct MKernelVectorDesc {
    void (*error)(char *msg, /* char *par1, *par2, */ ...);
	char* (*toMapleInteger)(int i);
	char* (*toMapleFloat)(double f);
	char* (*toMapleString)(const char *s);
	char* (*toMapleBoolean)(int b);
	void (*userinfo)(int level, char *name, char *msg);
} MKernelVectorDesc, *MKernelVector;

MKernelVectorDesc mykv = {
	&toMapleError,
	&toMapleInteger,
	&toMapleFloat,
	&toMapleString,
	&toMapleBoolean,
	&toMapleUserinfo
};

MKernelVector kv= &mykv;

static double dsn_zero=0.0;
static unsigned char dsn_undefC[8] = { 0, 0, 0, 0, 0, 0, 0xF8, 0x7F };
static double *dsn_undef = (double *)&dsn_undefC;
static unsigned char dsn_posinfC[8] = { 0, 0, 0, 0, 0, 0, 0xF0, 0x7F };
static double *dsn_posinf = (double *)&dsn_posinfC;
static unsigned char dsn_neginfC[8] = { 0, 0, 0, 0, 0, 0, 0xF0, 0xFF };
static double *dsn_neginf = (double *)&dsn_neginfC;
#define trunc(v) ( (v>0.0) ? floor(v) : ceil(v) )
#define IS_UNDEF(a) (a-a!=0. || (a!=0. && a-2.*a==0.))
#define UNUSED(a) ((void)(a))
double avoidcompilerwarn() { return(dsn_zero+*dsn_undef+*dsn_posinf+*dsn_neginf); }
static double dsn_U_Modelica_U_46_U_Math_U_46_U_Vectors_U_46_U_interpolate_U_126_U_iNew_U_46_U_proc_U_5_U_5(double *x, double *y, double xi, int iLast);



static const double _TID_T3[60] = {
0.00000000000000000e+000, 0.00000000000000000e+000, 5.00000000000000000e+002, 1.00000000000000000e+003,
	1.80000000000000000e+003, 3.00000000000000000e+003, 5.00000000000000000e+002, 2.20000000000000020e+000,
	2.20000000000000020e+000, 2.20000000000000020e+000, 2.20000000000000020e+000, 2.20000000000000020e+000,
	1.00000000000000000e+003, 2.20000000000000020e+000, 2.20000000000000020e+000, 2.20000000000000020e+000,
	2.20000000000000020e+000, 2.20000000000000020e+000, 1.50000000000000000e+003, 2.20000000000000020e+000,
	2.20000000000000020e+000, 2.20000000000000020e+000, 2.20000000000000020e+000, 2.20000000000000020e+000,
	2.00000000000000000e+003, 2.20000000000000020e+000, 2.20000000000000020e+000, 2.20000000000000020e+000,
	2.20000000000000020e+000, 2.20000000000000020e+000, 2.50000000000000000e+003, 2.20000000000000020e+000,
	2.20000000000000020e+000, 2.20000000000000020e+000, 2.20000000000000020e+000, 2.20000000000000020e+000,
	3.00000000000000000e+003, 2.20000000000000020e+000, 2.20000000000000020e+000, 2.20000000000000020e+000,
	2.20000000000000020e+000, 2.20000000000000020e+000, 5.00000000000000000e+003, 2.20000000000000020e+000,
	2.20000000000000020e+000, 2.20000000000000020e+000, 2.20000000000000020e+000, 2.20000000000000020e+000,
	6.00000000000000000e+003, 2.20000000000000020e+000, 2.20000000000000020e+000, 2.20000000000000020e+000,
	2.20000000000000020e+000, 2.20000000000000020e+000, 7.00000000000000000e+003, 2.20000000000000020e+000,
	2.20000000000000020e+000, 2.20000000000000020e+000, 2.20000000000000020e+000, 2.20000000000000020e+000};

static const double _TID_T1[60] = {
0.00000000000000000e+000, 0.00000000000000000e+000, 5.00000000000000000e+002, 1.00000000000000000e+003,
	1.80000000000000000e+003, 3.00000000000000000e+003, 5.00000000000000000e+002, 2.20000000000000020e+000,
	2.20000000000000020e+000, 2.20000000000000020e+000, 2.20000000000000020e+000, 2.20000000000000020e+000,
	1.00000000000000000e+003, 2.20000000000000020e+000, 2.20000000000000020e+000, 2.20000000000000020e+000,
	2.20000000000000020e+000, 2.20000000000000020e+000, 1.50000000000000000e+003, 2.20000000000000020e+000,
	2.20000000000000020e+000, 2.20000000000000020e+000, 2.20000000000000020e+000, 2.20000000000000020e+000,
	2.00000000000000000e+003, 2.20000000000000020e+000, 2.20000000000000020e+000, 2.20000000000000020e+000,
	2.20000000000000020e+000, 2.20000000000000020e+000, 2.50000000000000000e+003, 2.20000000000000020e+000,
	2.20000000000000020e+000, 2.20000000000000020e+000, 2.20000000000000020e+000, 2.20000000000000020e+000,
	3.00000000000000000e+003, 2.20000000000000020e+000, 2.20000000000000020e+000, 2.20000000000000020e+000,
	2.20000000000000020e+000, 2.20000000000000020e+000, 5.00000000000000000e+003, 2.20000000000000020e+000,
	2.20000000000000020e+000, 2.20000000000000020e+000, 2.20000000000000020e+000, 2.20000000000000020e+000,
	6.00000000000000000e+003, 2.20000000000000020e+000, 2.20000000000000020e+000, 2.20000000000000020e+000,
	2.20000000000000020e+000, 2.20000000000000020e+000, 7.00000000000000000e+003, 2.20000000000000020e+000,
	2.20000000000000020e+000, 2.20000000000000020e+000, 2.20000000000000020e+000, 2.20000000000000020e+000};

static const double _TID_T5[60] = {
0.00000000000000000e+000, 0.00000000000000000e+000, 5.00000000000000000e+002, 1.00000000000000000e+003,
	1.80000000000000000e+003, 3.00000000000000000e+003, 5.00000000000000000e+002, 2.20000000000000020e+000,
	2.20000000000000020e+000, 2.20000000000000020e+000, 2.20000000000000020e+000, 2.20000000000000020e+000,
	1.00000000000000000e+003, 2.20000000000000020e+000, 2.20000000000000020e+000, 2.20000000000000020e+000,
	2.20000000000000020e+000, 2.20000000000000020e+000, 1.50000000000000000e+003, 2.20000000000000020e+000,
	2.20000000000000020e+000, 2.20000000000000020e+000, 2.20000000000000020e+000, 2.20000000000000020e+000,
	2.00000000000000000e+003, 2.20000000000000020e+000, 2.20000000000000020e+000, 2.20000000000000020e+000,
	2.20000000000000020e+000, 2.20000000000000020e+000, 2.50000000000000000e+003, 2.20000000000000020e+000,
	2.20000000000000020e+000, 2.20000000000000020e+000, 2.20000000000000020e+000, 2.20000000000000020e+000,
	3.00000000000000000e+003, 2.20000000000000020e+000, 2.20000000000000020e+000, 2.20000000000000020e+000,
	2.20000000000000020e+000, 2.20000000000000020e+000, 5.00000000000000000e+003, 2.20000000000000020e+000,
	2.20000000000000020e+000, 2.20000000000000020e+000, 2.20000000000000020e+000, 2.20000000000000020e+000,
	6.00000000000000000e+003, 2.20000000000000020e+000, 2.20000000000000020e+000, 2.20000000000000020e+000,
	2.20000000000000020e+000, 2.20000000000000020e+000, 7.00000000000000000e+003, 2.20000000000000020e+000,
	2.20000000000000020e+000, 2.20000000000000020e+000, 2.20000000000000020e+000, 2.20000000000000020e+000};

static const double _TID_T4[60] = {
0.00000000000000000e+000, 0.00000000000000000e+000, 5.00000000000000000e+002, 1.00000000000000000e+003,
	1.80000000000000000e+003, 3.00000000000000000e+003, 5.00000000000000000e+002, 2.20000000000000020e+000,
	2.20000000000000020e+000, 2.20000000000000020e+000, 2.20000000000000020e+000, 2.20000000000000020e+000,
	1.00000000000000000e+003, 2.20000000000000020e+000, 2.20000000000000020e+000, 2.20000000000000020e+000,
	2.20000000000000020e+000, 2.20000000000000020e+000, 1.50000000000000000e+003, 2.20000000000000020e+000,
	2.20000000000000020e+000, 2.20000000000000020e+000, 2.20000000000000020e+000, 2.20000000000000020e+000,
	2.00000000000000000e+003, 2.20000000000000020e+000, 2.20000000000000020e+000, 2.20000000000000020e+000,
	2.20000000000000020e+000, 2.20000000000000020e+000, 2.50000000000000000e+003, 2.20000000000000020e+000,
	2.20000000000000020e+000, 2.20000000000000020e+000, 2.20000000000000020e+000, 2.20000000000000020e+000,
	3.00000000000000000e+003, 2.20000000000000020e+000, 2.20000000000000020e+000, 2.20000000000000020e+000,
	2.20000000000000020e+000, 2.20000000000000020e+000, 5.00000000000000000e+003, 2.20000000000000020e+000,
	2.20000000000000020e+000, 2.20000000000000020e+000, 2.20000000000000020e+000, 2.20000000000000020e+000,
	6.00000000000000000e+003, 2.20000000000000020e+000, 2.20000000000000020e+000, 2.20000000000000020e+000,
	2.20000000000000020e+000, 2.20000000000000020e+000, 7.00000000000000000e+003, 2.20000000000000020e+000,
	2.20000000000000020e+000, 2.20000000000000020e+000, 2.20000000000000020e+000, 2.20000000000000020e+000};

static const double _TID_T2[60] = {
0.00000000000000000e+000, 0.00000000000000000e+000, 5.00000000000000000e+002, 1.00000000000000000e+003,
	1.80000000000000000e+003, 3.00000000000000000e+003, 5.00000000000000000e+002, 2.20000000000000020e+000,
	2.20000000000000020e+000, 2.20000000000000020e+000, 2.20000000000000020e+000, 2.20000000000000020e+000,
	1.00000000000000000e+003, 2.20000000000000020e+000, 2.20000000000000020e+000, 2.20000000000000020e+000,
	2.20000000000000020e+000, 2.20000000000000020e+000, 1.50000000000000000e+003, 2.20000000000000020e+000,
	2.20000000000000020e+000, 2.20000000000000020e+000, 2.20000000000000020e+000, 2.20000000000000020e+000,
	2.00000000000000000e+003, 2.20000000000000020e+000, 2.20000000000000020e+000, 2.20000000000000020e+000,
	2.20000000000000020e+000, 2.20000000000000020e+000, 2.50000000000000000e+003, 2.20000000000000020e+000,
	2.20000000000000020e+000, 2.20000000000000020e+000, 2.20000000000000020e+000, 2.20000000000000020e+000,
	3.00000000000000000e+003, 2.20000000000000020e+000, 2.20000000000000020e+000, 2.20000000000000020e+000,
	2.20000000000000020e+000, 2.20000000000000020e+000, 5.00000000000000000e+003, 2.20000000000000020e+000,
	2.20000000000000020e+000, 2.20000000000000020e+000, 2.20000000000000020e+000, 2.20000000000000020e+000,
	6.00000000000000000e+003, 2.20000000000000020e+000, 2.20000000000000020e+000, 2.20000000000000020e+000,
	2.20000000000000020e+000, 2.20000000000000020e+000, 7.00000000000000000e+003, 2.20000000000000020e+000,
	2.20000000000000020e+000, 2.20000000000000020e+000, 2.20000000000000020e+000, 2.20000000000000020e+000};
static const M_INT _TID_NUMBER = 5;
static const double *_TID_TABLE[5] = {_TID_T1,_TID_T2,_TID_T3,_TID_T4,_TID_T5};
static const M_INT _TID_D1[5] = {10,10,10,10,10};
static const M_INT _TID_D2[5] = {6,6,6,6,6};
static const M_INT _TID_SMOOTH[5] = {0,0,0,0,0};
static const M_INT _TID_EXTRA[5] = {2,2,2,2,2};


#ifdef MSVC
#pragma optimize( "ty", on)
#endif
static double Interp2Dsim(M_INT tid, double x, double y, M_INT dx, M_INT dy)
{
	double da[4], dy1, dy2, t0, t1, t2, t3, t4, t5, v1[4], x1, x2, y1, y2;
	M_INT extra, i, ix, j, jh, jl, m, nx, ny, typ;
	const double *T;

	if( tid<1 || tid>_TID_NUMBER )
		return(*dsn_undef);
	T = _TID_TABLE[tid-1];
	nx = _TID_D1[tid-1]-1;
	ny = _TID_D2[tid-1]-1;
	typ = _TID_SMOOTH[tid-1];
	extra = _TID_EXTRA[tid-1];

	if( (typ!=-1 && typ!=0 && typ!=1) || (extra<0 || extra>3) )
		return(*dsn_undef);
	if( ( typ==-1 && (dx>0 || dy>0) ) || ( typ==0 && (dx>1 || dy>1) )
		|| ( typ==1 && (dx>3 || dy>3) ) )
		return(0.);
	i = 1;
	ix = nx-1;
	while( i-ix<0 ) {
		m = (i+ix+1)/2;
		if( x<T[m*(ny+1)] ) ix = m-1; else i = m;
	}
	j = 1;
	ix = ny-1;
	while( ix-j>0 ) {
		m = (j+ix+1)/2;
		if( y<T[m] ) ix = m-1; else j = m;
	}
	if( extra==0 && ( (i==1 && x<T[ny+1]) || (i==nx-1 && T[nx*(ny+1)]<x) ||
						 	(j==1 && y<T[1]) || (j==ny-1 && T[ny]<y) ) )
		return(*dsn_undef);
	if( typ==-1 ) {
		if( nx>1 && x>T[(i+1)*(ny+1)] ) i++;
		if( ny>1 && y>T[j+1] ) j++;
		return( T[i*(ny+1)+j] );
	}
	if( ny==1 ) {
		jl = j;
		jh = j;
	}
	else {
		jl = (typ==0 || j==1) ? j : j-1;
		jh = (typ==0 || j==ny-1) ? j+1 : j+2;
	}
	if( nx==1 ) {
		if( dx==0 )
			for(ix=jl-1;ix<jh;ix++)
				v1[ix-j+2] = T[ny+1+ix+1];
		else
			return(0.);
	}
	else if( (i==1 && x<T[ny+1]) && (extra<2 || (typ==1 && extra==2)) ) {
		if( extra==1 ) {
			if( dx==0 )
				for(ix=jl-1;ix<jh;ix++)
					v1[ix-j+2] = T[ny+1+ix+1];
			else
				return(0.);
		}
		else if( dx>=2 )
			return(0.);
		else {
			t0 = (-1.)/(T[ny+1]-T[2*(ny+1)]);
			for(ix=jl-1;ix<jh;ix++)
				v1[ix-j+2] = t0*(T[2*(ny+1)+ix+1]-T[ny+1+ix+1]);
			if( dx==0 ) {
				t0 = x-T[ny+1];
				for(ix=jl-1;ix<jh;ix++)
					v1[ix-j+2] = T[ny+1+ix+1]+t0*v1[ix-j+2];
			}
		}
	}
	else if( (i==nx-1 && T[nx*(ny+1)]<x) && (extra<2 || (typ==1 && extra==2)) ) {
		if( extra==1 ) {
			if( dx==0 )
				for(ix=jl-1;ix<jh;ix++)
					v1[ix-j+2] = T[nx*(ny+1)+ix+1];
			else
				return(0.);
		}
		else if( dx>=2 )
			return(0.);
		else {
			t0 = (-1.)/(T[(nx-1)*(ny+1)]-T[nx*(ny+1)]);
			for(ix=jl-1;ix<jh;ix++)
				v1[ix-j+2] = t0*(T[nx*(ny+1)+ix+1]-T[(nx-1)*(ny+1)+ix+1]);
			if( dx==0 ) {
				t0 = x-T[nx*(ny+1)];
				for(ix=jl-1;ix<jh;ix++)
					v1[ix-j+2] = T[nx*(ny+1)+ix+1]+t0*v1[ix-j+2];
			}
		}
	}
	else if(nx==2 || typ==0) {
		t0 = T[(i+1)*(ny+1)]-T[i*(ny+1)];
		if( t0==0. )
			t0 = 1.;
		else
			t0 = 1./t0;
		if( dx==0 ) {
			t1 = t0*(T[(i+1)*(ny+1)]-x);
			t2 = -t1+1.;
			for(ix=jl-1;ix<jh;ix++)
				v1[ix-j+2] = t1*T[i*(ny+1)+ix+1]+t2*T[(i+1)*(ny+1)+ix+1];
		}
		else if( dx==1 )
			for(ix=jl-1;ix<jh;ix++)
				v1[ix-j+2] = t0*(T[(i+1)*(ny+1)+ix+1]-T[i*(ny+1)+ix+1]);
		else
			return(0.);
	}
	else if(i==1 && extra==3) {
		if( dx==3 )
			return(0.);
		t0 = T[2*(ny+1)]-T[ny+1];
		t1 = T[3*(ny+1)]-T[2*(ny+1)];
		t2 = T[3*(ny+1)]-T[ny+1];
		t4 = 1./(t0*t1*t2);
		t3 = t4*t0;
		t4 = t4*t1;
		for(ix=jl-1;ix<jh;ix++)
			v1[ix-j+2] = t3*(t0*T[3*(ny+1)+ix+1]-t2*T[2*(ny+1)+ix+1])+t4*(t2*T[2*(ny+1)+ix+1]-t1*T[ny+1+ix+1]);
		t1 = 1./t0;
		t1 = t1*t1;
		if( dx==2 ) {
			t3 = 2.*t1;
			for(ix=jl-1;ix<jh;ix++)
				v1[ix-j+2] = t3*(t0*v1[ix-j+2]+T[ny+1+ix+1]-T[2*(ny+1)+ix+1]);
		}
		else {
			x1 = x-T[ny+1];
			x2 = x-T[2*(ny+1)];
			if( dx==1 ) {
				t3 = t1*t0*(x2+x1);
				t4 = 2.*t1*x2;
				for(ix=jl-1;ix<jh;ix++)
					v1[ix-j+2] = t3*v1[ix-j+2]-t4*(T[2*(ny+1)+ix+1]-T[ny+1+ix+1]);
			}
			else {
				t2 = t1*t0*x2*x1;
				t3 = t1*x1*(-x1+2.*x2);
				t4 = t1*x1*x1;
				for(ix=jl-1;ix<jh;ix++)
					v1[ix-j+2] = t2*v1[ix-j+2]+t4*T[ny+1+ix+1]-t3*T[2*(ny+1)+ix+1];
			}
		}
	}
	else if(i==nx-1 && extra==3) {
		if( dx==3 )
			return(0.);
		t0 = T[nx*(ny+1)]-T[(nx-1)*(ny+1)];
		t1 = T[(nx-1)*(ny+1)]-T[(nx-2)*(ny+1)];
		t2 = T[nx*(ny+1)]-T[(nx-2)*(ny+1)];
		t4 = 1./(t0*t1*t2);
		t3 = t4*t1;
		t4 = t4*t0;
		for(ix=jl-1;ix<jh;ix++)
			v1[ix-j+2] = t3*(t1*T[nx*(ny+1)+ix+1]-t2*T[(nx-1)*(ny+1)+ix+1])+t4*(t2*T[(nx-1)*(ny+1)+ix+1]-t0*T[(nx-2)*(ny+1)+ix+1]);
		t1 = 1./t0;
		t1 = t1*t1;
		if( dx==2 ) {
			t3 = 2.*t1;
			for(ix=jl-1;ix<jh;ix++)
				v1[ix-j+2] = t3*(T[nx*(ny+1)+ix+1]-t0*v1[ix-j+2]-T[(nx-1)*(ny+1)+ix+1]);
		}
		else {
			x1 = x-T[(nx-1)*(ny+1)];
			x2 = x-T[nx*(ny+1)];
			if( dx==1 ) {
				t3 = -t1*t0*(x2+x1);
				t4 = 2.*t1*x1;
				for(ix=jl-1;ix<jh;ix++)
					v1[ix-j+2] = t3*v1[ix-j+2]+t4*(T[nx*(ny+1)+ix+1]-T[(nx-1)*(ny+1)+ix+1]);
			}
			else {
				t2 = -t1*t0*x2*x1;
				t3 = t1*x1*x1;
				t4 = t1*x2*(-x2+2.*x1);
				for(ix=jl-1;ix<jh;ix++)
					v1[ix-j+2] = t2*v1[ix-j+2]+t3*T[nx*(ny+1)+ix+1]-t4*T[(nx-1)*(ny+1)+ix+1];
			}
		}
	}
	else {
		t0 = T[(i+1)*(ny+1)]-T[i*(ny+1)];
		t5 = 1./t0;
		if( i==1 ) {
			if( extra==1 )
				for(ix=jl-1;ix<jh;ix++)
					v1[ix-j+2] = 0.;
			else
				for(ix=jl-1;ix<jh;ix++)
					v1[ix-j+2] = t5*(T[2*(ny+1)+ix+1]-T[ny+1+ix+1]);
		}
		else {
			t1 = T[i*(ny+1)]-T[(i-1)*(ny+1)];
			t2 = T[(i+1)*(ny+1)]-T[(i-1)*(ny+1)];
			t4 = 1./(t0*t1*t2);
			t3 = t4*t1;
			t4 = t4*t0;
			for(ix=jl-1;ix<jh;ix++)
				v1[ix-j+2] = t3*(t1*T[(i+1)*(ny+1)+ix+1]-t2*T[i*(ny+1)+ix+1])+t4*(t2*T[i*(ny+1)+ix+1]-t0*T[(i-1)*(ny+1)+ix+1]);
		}
		if( i==nx-1 ) {
			if( extra==1 )
				for(ix=jl-1;ix<jh;ix++)
					da[ix-j+2] = 0.;
			else
				for(ix=jl-1;ix<jh;ix++)
					da[ix-j+2] = t5*(T[nx*(ny+1)+ix+1]-T[(nx-1)*(ny+1)+ix+1]);
		}
		else {
			t1 = T[(i+2)*(ny+1)]-T[(i+1)*(ny+1)];
			t2 = T[(i+2)*(ny+1)]-T[i*(ny+1)];
			t4 = 1./(t0*t1*t2);
			t3 = t4*t0;
			t4 = t4*t1;
			for(ix=jl-1;ix<jh;ix++)
				da[ix-j+2] = t3*(t0*T[(i+2)*(ny+1)+ix+1]-t2*T[(i+1)*(ny+1)+ix+1])+t4*(t2*T[(i+1)*(ny+1)+ix+1]-t1*T[i*(ny+1)+ix+1]);
		}
		t1 = t5*t5*t5;
		if( dx==3 ) {
			t3 = 6.*t1;
			t2 = t0*t3;
			t3 = 2.*t3;
			for(ix=jl-1;ix<jh;ix++)
				v1[ix-j+2] = t2*(v1[ix-j+2]+da[ix-j+2])-t3*(T[(i+1)*(ny+1)+ix+1]-T[i*(ny+1)+ix+1]);
		}
		else {
			x1 = x-T[i*(ny+1)];
			x2 = x-T[(i+1)*(ny+1)];
			if( dx==2 ) {
				t3 = 2.*t1*t0;
				t2 = t3*(x1+2.*x2);
				t3 = t3*(x2+2.*x1);
				t4 = 6.*t1*(x2+x1);
				for(ix=jl-1;ix<jh;ix++)
					v1[ix-j+2] = t2*v1[ix-j+2]+t3*da[ix-j+2]-t4*(T[(i+1)*(ny+1)+ix+1]-T[i*(ny+1)+ix+1]);
			}
			else if( dx==1 ) {
				t3 = t1*t0;
				t2 = t3*x2*(x2+2.*x1);
				t3 = t3*x1*(x1+2.*x2);
				t4 = 6.*t1*x2*x1;
				for(ix=jl-1;ix<jh;ix++)
					v1[ix-j+2] = t2*v1[ix-j+2]+t3*da[ix-j+2]-t4*(T[(i+1)*(ny+1)+ix+1]-T[i*(ny+1)+ix+1]);
			}
			else {
				t3 = t1*t0*x2*x1;
				t2 = t3*x2;
				t3 = t3*x1;
				t4 = t1*x1*x1*(-x1+3.*x2);
				t5 = t1*x2*x2*(-x2+3.*x1);
				for(ix=jl-1;ix<jh;ix++)
					v1[ix-j+2] = t2*v1[ix-j+2]+t3*da[ix-j+2]+t5*T[i*(ny+1)+ix+1]-t4*T[(i+1)*(ny+1)+ix+1];
			}
		}
	}

	if( ny==1 ) {
		if( dy==0 )
			return(v1[1]);
		else
			return(0.);
	}
	else if( (j==1 && y<T[1]) && (extra<2 || (typ==1 && extra==2)) ) {
		if( extra==1 ) {
			if( dy==0 )
				return(v1[1]);
			else
				return(0.);
		}
		else if( dy>=2 )
			return(0.);
		else {
			t1 = (v1[1]-v1[2])/(T[1]-T[2]);
			if( dy==0 )
				return(v1[1]+t1*(y-T[1]));
			return(t1);
		}
	}
	else if( (j==ny-1 && T[ny]<y) && (extra<2 || (typ==1 && extra==2)) ) {
		if( extra==1 ) {
			if( dy==0 )
				return(v1[2]);
			else
				return(0.);
		}
		else if( dy>=2 )
			return(0.);
		else {
			t1 = (v1[1]-v1[2])/(T[ny-1]-T[ny]);
			if( dy==0 )
				return(v1[2]+t1*(y-T[ny]));
			return(t1);
		}
	}
	else if(ny==2 || typ==0) {
		t0 = T[j+1]-T[j];
		if( t0==0. )
			t0 = 1.;
		else
			t0 = 1./t0;
		if( dy==0 ) {
			t1 = t0*(T[j+1]-y);
			t2 = -t1+1.;
			return(t1*v1[1]+t2*v1[2]);
		}
		else if( dy==1 )
			return(t0*(v1[2]-v1[1]));
		else
			return(0.);
	}
	else if(j==1 && extra==3) {
		if( dy==3 )
			return(0.);
		t0 = T[2]-T[1];
		t1 = T[3]-T[2];
		t2 = T[3]-T[1];
		dy2 = (t0*t0*v1[3]+t1*t2*v1[2]-t0*t2*v1[2]-t1*t1*v1[1])/(t0*t1*t2);
		t1 = 1./t0;
		t1 = t1*t1;
		if( dy==2 )
			return(2.*t1*(t0*dy2+v1[1]-v1[2]));
		else {
			y1 = y-T[1];
			y2 = y-T[2];
			if( dy==1 )
				return(t1*(t0*(y2+y1)*dy2-2.*y2*(v1[2]-v1[1])));
			else
				return(t1*(t0*y2*y1*dy2+y2*y2*v1[1]-y1*(-y1+2.*y2)*v1[2]));
		}
	}
	else if(j==ny-1 && extra==3) {
		if( dy==3 )
			return(0.);
		t0 = T[ny]-T[ny-1];
		t1 = T[ny-1]-T[ny-2];
		t2 = T[ny]-T[ny-2];
		dy1 = (t1*t1*v1[2]+t0*t2*v1[1]-t1*t2*v1[1]-t0*t0*v1[0])/(t0*t1*t2);
		t1 = 1./t0;
		t1 = t1*t1;
		if( dy==2 )
			return(2.*t1*(v1[2]-t0*dy1-v1[1]));
		else {
			y1 = y-T[ny-1];
			y2 = y-T[ny];
			if( dy==1 )
				return(t1*(-t0*(y2+y1)*dy1+2.*y1*(v1[2]-v1[1])));
			else
				return(t1*(y1*y1*v1[2]-t0*y2*y1*dy1-y2*(-y2+2.*y1)*v1[1]));
		}
	}
	else {
		t0 = T[j+1]-T[j];
		if( j==1 ) {
			if( extra==1 )
				dy1 = 0.;
			else
				dy1 = (v1[1]-v1[2])/(T[1]-T[2]);
		}
		else {
			t1 = T[j]-T[j-1];
			t2 = T[j+1]-T[j-1];
			dy1 = (t1*t1*v1[2]+t0*t2*v1[1]-t1*t2*v1[1]-t0*t0*v1[0])/(t0*t1*t2);
		}
		if( j==ny-1 ) {
			if( extra==1 )
				dy2 = 0.;
			else
				dy2 = (v1[1]-v1[2])/(T[ny-1]-T[ny]);
		}
		else {
			t1 = T[j+2]-T[j+1];
			t2 = T[j+2]-T[j];
			dy2 = (t0*t0*v1[3]+t1*t2*v1[2]-t0*t2*v1[2]-t1*t1*v1[1])/(t0*t1*t2);
		}
		t1 = 1./t0;
		t1 = t1*t1*t1;
		if( dy==3 )
			return(6.*t1*(t0*(dy2+dy1)+2.*(v1[1]-v1[2])));
		else {
			y1 = y-T[j];
			y2 = y-T[j+1];
			if( dy==2 )
				return(2.*t1*(t0*((y1+2.*y2)*dy1+(y2+2.*y1)*dy2)-3.*(y2+y1)*(v1[2]-v1[1])));
			else if( dy==1 )
				return(t1*(t0*(y2*(y2+2.*y1)*dy1+y1*(y1+2.*y2)*dy2)-6.*y2*y1*(v1[2]-v1[1])));
			else
				return(t1*(t0*y2*y1*(y2*dy1+y1*dy2)+y2*y2*(-y2+3.*y1)*v1[1]-y1*y1*(-y1+3.*y2)*v1[2]));
		}
	}
}
#ifdef MSVC
#pragma optimize( "", on)
#endif

static double dsn_U_Modelica_U_46_U_Math_U_46_U_Vectors_U_46_U_interpolate_U_126_U_iNew_U_46_U_proc_U_5_U_5(double *x, double *y, double xi, int iLast)
{
	double yi, nx, x1, x2, y1, y2;
	int i;

	nx = 5.;
	if( nx<=0. ) {
		{
			kv->error("Modelica assertion (0 < nx) failed in `Modelica.Math.Vectors.'interpolate~iNew'`: The table vectors must have at least 1 entry.");
			return(0.0);
		}
	}
	if( nx==1. )
		yi = y[0];
	else {
		i = ( (( (iLast>1) ? ((double)iLast) : 1. )<nx-1.) ? ( (iLast>1) ? iLast : 1 ) : ((int)(trunc(nx)))-1 );
		if( x[i-1]<=xi ) {
			while( (((double)i)<nx) && (x[i-1]<=xi) ) {
				i = i+1;
			}
			i = i-1;
		}
		else {
			while( (i>1) && (xi<x[i-1]) ) {
				i = i-1;
			}
		}
		x1 = x[i-1];
		x2 = x[i];
		y1 = y[i-1];
		y2 = y[i];
		if( x2<=x1 ) {
			{
				kv->error("Modelica assertion (x1 < x2) failed in `Modelica.Math.Vectors.'interpolate~iNew'`: Abscissa table vector values must be increasing");
				return(0.0);
			}
		}
		yi = y1+((y2-y1)*(xi-x1))/(x2-x1);
	}
	return(yi);
}


void fp_sub1(int N, double T, double *Y, double *YP, double *Z)
{
	UNUSED(N);
	UNUSED(T);
	Z[0] = 9.54929658551372013*Y[11];
	Y[2] = Interp2Dsim(((int)(trunc(Y[12]))),Z[0],Y[0],0,0);
	Y[3] = Interp2Dsim(((int)(trunc(Y[13]))),Z[0],Y[0],0,0);
	Y[4] = Interp2Dsim(((int)(trunc(Y[14]))),Z[0],Y[0],0,0);
	Y[5] = Interp2Dsim(((int)(trunc(Y[15]))),Z[0],Y[0],0,0);
	Y[6] = Interp2Dsim(((int)(trunc(Y[16]))),Z[0],Y[0],0,0);
	YP[0] = -100.*Y[0]+0.1*Y[10];
}
static void fp(int N, double T, double *Y, double *YP)
{
	double Z[2], Ma1[5], Ma2[5];

	fp_sub1(N,T,Y,YP,Z);
	if( (Y[20]==1.) || (Y[19]==1.) ) {
		if( Y[20]==1. )
			Y[1] = Y[2];
		else
			Y[1] = Y[6];
	}
	else {
		Ma1[0] = 4.1e-06;
		Ma1[1] = Y[21];
		Ma1[2] = Y[22];
		Ma1[3] = Y[23];
		Ma1[4] = 0.0000394;
		Ma2[0] = Y[2];
		Ma2[1] = Y[3];
		Ma2[2] = Y[4];
		Ma2[3] = Y[5];
		Ma2[4] = Y[6];
		Z[1] = dsn_U_Modelica_U_46_U_Math_U_46_U_Vectors_U_46_U_interpolate_U_126_U_iNew_U_46_U_proc_U_5_U_5(Ma1,Ma2,Y[9],1);
		Y[1] = Z[1];
	}
}

static void otp(double T, double *Y, double *YP)
{
	double Z[1];

	UNUSED(T);
	UNUSED(YP);
	Z[0] = Y[11];
	Y[7] = -tanh(10.*Z[0])*Y[1];
	Y[8] = Z[0]*Y[1];
}

static void eev(double T, double *Y, double *Ypre, double *EA)
{
	UNUSED(T);
	UNUSED(Ypre);
	EA[0] = Y[9]-0.0000394;
	EA[1] = -Y[9]+4.1e-06;
}

static int eex(int N, double T, double *Y, double *Ypre)
{
	UNUSED(T);
	UNUSED(Ypre);
	if( N==1 )
		Y[19] = 1.-Y[19];
	else if( N==2 )
		Y[20] = 1.-Y[20];
	else if( N==3 ) {
		if( Y[17]==1. )
			Y[12] = 1.;
		if( Y[17]==1. )
			Y[13] = 2.;
		if( Y[17]==1. )
			Y[14] = 3.;
		if( Y[17]==1. )
			Y[15] = 4.;
		if( Y[17]==1. )
			Y[16] = 5.;
		if( !(floor(Y[12]+0.5)==Y[12]) ) {
			Y[18] = 1.;
			return(1);
		}
		if( !(floor(Y[13]+0.5)==Y[13]) ) {
			Y[18] = 2.;
			return(1);
		}
		if( !(floor(Y[14]+0.5)==Y[14]) ) {
			Y[18] = 3.;
			return(1);
		}
		if( !(floor(Y[15]+0.5)==Y[15]) ) {
			Y[18] = 4.;
			return(1);
		}
		if( !(floor(Y[16]+0.5)==Y[16]) ) {
			Y[18] = 5.;
			return(1);
		}
		if( Y[17]==1. )
			Y[17] = 0.;
	}
	return(0);
}

static int cpr(double T, double *Y)
{
	double v;
	int k;

	UNUSED(T);
	k = 0;
	if( Y[9]>=0.0000394 )
		v = 1.;
	else
		v = 0.;
	if( Y[19]!=v ) {
		Y[19] = v;
		k = 1;
	}
	if( Y[9]<4.1e-06 )
		v = 1.;
	else
		v = 0.;
	if( Y[20]!=v ) {
		Y[20] = v;
		k = 1;
	}
	return(k);
}

static void terminate(double T, double *Y, int j)
{
	UNUSED(Y);
	if(j==1) SolverError(T,1,"variable `Main.OP2.combiTable3D1.combiTable2D1[1].tableID`(t) must be integer valued");
	if(j==2) SolverError(T,1,"variable `Main.OP2.combiTable3D1.combiTable2D1[2].tableID`(t) must be integer valued");
	if(j==3) SolverError(T,1,"variable `Main.OP2.combiTable3D1.combiTable2D1[3].tableID`(t) must be integer valued");
	if(j==4) SolverError(T,1,"variable `Main.OP2.combiTable3D1.combiTable2D1[4].tableID`(t) must be integer valued");
	if(j==5) SolverError(T,1,"variable `Main.OP2.combiTable3D1.combiTable2D1[5].tableID`(t) must be integer valued");
}

static void InitEventModes(double *tval, double *y,
	M_INT *modes, M_INT *req, M_INT *inc)
{
	int i;

	for(i=0;i<NEVT;i++) {
		if(tval[i]>0.0)
			modes[i]=1;
		else if(tval[i]<0.0)
			modes[i]=0;
		else if(req[i]>0) {
			if(y[req[i]-1]==1.0)
				modes[i]=1;
			else
				modes[i]=0;
		}
		else if(inc[i])
			modes[i]=0;
		else
			modes[i]=1;
	}
}

static int ComputeEventIndicators(double *tval, double *y,
	M_INT *modes, M_INT *req, M_INT *inc, M_INT *ivl)
{
	int i;

	for(i=0;i<NEVT;i++) {
		if(req[i]>0) {
			/* Requires triggers - have an assoc. state variable, so we
				know the expected state */
			if(y[req[i]-1]==1.0)
				tval[i]+=FMUHYST;
			else
				tval[i]-=FMUHYST;
		}
		else if(inc[i]) {
			/* Increase-only trigger */
			if(modes[i]==0)
				tval[i]-=FMUHYST;
			else
				tval[i]+=FMUHYST;
		}
		else if(ivl[i]>0) {
			/* Integer-shift trigger */
			tval[i]-=FMUHYST;
		}
		else return(-1); /* Bad event */
	}
	return(0);
}

static int CheckEvents(double *tval, double *yt, M_INT *modes,
	M_INT *oldmodes, M_INT *req, M_INT *inc, M_INT *ivl)
{
	int i,flag;

	flag=0;
	for(i=0;i<NEVT;i++) {
		if(req[i]>0) {
			/* Requires triggers - have an assoc. state variable, so we
				do not need to rely on 'oldmodes' */
			if(yt[req[i]]==1.0) {
				/* Switch orig in '+' state */
				if( tval[i]<-EVTHYST ) {
					oldmodes[i]=1; modes[i]=0; flag=1;
				}
				else {
					oldmodes[i]=1; modes[i]=1;
				}
			}
			else {
				/* Switch orig in '-' state */
				if( tval[i]>EVTHYST ) {
					oldmodes[i]=0; modes[i]=1; flag=1;
				}
				else {
					oldmodes[i]=0; modes[i]=0;
				}
			}
		}
		else if(inc[i]) {
			/* Increase-only triggers */
			if(oldmodes[i]==0 && tval[i]>EVTHYST) {
				modes[i]=1; flag=1;
			}
			else if(oldmodes[i]==1 && tval[i]<-EVTHYST ) {
				oldmodes[i]=0; modes[i]=0;
			}
		}
		else if(ivl[i]>0) {
			/* Integer-shift trigger */
			if(tval[i]<-EVTHYST) {
				oldmodes[i]=1; modes[i]=0; flag=1;
			}
			else {
				oldmodes[i]=1; modes[i]=1;
			}
		}
		else return(-1); /* Bad event */
	}
	return(flag);
}

static int RunEvents(double *w, M_INT *modes, int first,
	int termvar, int maxiter, double *psto)
{
	double t,*y,*yp,*ypre,*tval;
	M_INT *m=NULL,*oldmodes,*inc,*req,*ivl;
	int i,flag,iter,evt,rc,failskip;

	/* Transfer data to approp. named arrays */
	t=w[0]; y=&w[1]; yp=&y[NEQ+NPAR]; ypre=&yp[NDFA]; tval=&ypre[NEQ];
	oldmodes=&modes[NEVT]; inc=&oldmodes[NEVT]; req=&inc[NEVT], ivl=&req[NEVT];
	/* Verify that no y values are undefined */
	for(i=0;i<NEQ;i++)
		if(IS_UNDEF(y[i])) {
			if (errorOccured<=0) {
				errorOccured = 1;
				sprintf(errorString,"undefined value encountered on entry into RunEvents at t=%f",t);
			}
			return(-3);
		}
	/* Set the old modes to the new and ypre to y */
	for(i=0;i<NEVT;i++) oldmodes[i]=modes[i];
	for(i=0;i<NEQ;i++) ypre[i]=y[i];

	if(first!=1) {
		/* Check for events */
		eev(t,y,ypre,tval);
		flag=CheckEvents(tval,y-1,modes,oldmodes,req,inc,ivl);
		if(flag<0) {
			if (errorOccured<=0) {
				errorOccured = 1;
				sprintf(errorString,"internal error: bad event at t=%f",t);

			}	
			return(-5);
		}
		/* If no events, return, but still need to update modes as we may
			have a sign change for a decrease on an increase-only trigger */
		if(!first && !flag) {
			if(m) for(i=0;i<NEVT;i++) m[i]=modes[i];
			return(0);
		}
	}

	/* Iteration loop */
	failskip=0;
	for(iter=0;;iter++) {
		if( first!=1 || iter>0 )
			/* Event loop */
			for(evt=0;evt<NEVT;evt++)
				if(modes[evt]!=oldmodes[evt]) {
					rc=eex(evt+1,t,y,ypre);
					if(termvar>=0 && y[termvar]>0.0) {
						i=(int)y[termvar];
						terminate(t,y,i);
						return(i);
					}
					/* Handle RC */
					oldmodes[evt]=modes[evt];
				}

		/* Discrete equations */
		rc=eex(NEVT+1,t,y,ypre);
		/* Fail skip */
		if(rc==8 && !failskip) {
			failskip=1;
			iter--;
			if(termvar>=0) y[termvar]=0.0;
		}
		else
			failskip=0;
		if(termvar>=0 && y[termvar]>0.0) {
			i=(int)y[termvar];
			terminate(t,y,i);
			return(i);
		}
		/* Handle RC */

		/* Check for termination */
		for(i=0;i<NEQ;i++) if(y[i]!=ypre[i]) break;
		if( !failskip && i==NEQ ) {
			/* Update modes and return */
			if(m) for(i=0;i<NEVT;i++) m[i]=modes[i];
			return(0);
		}

		/* Check iter limit */
		if( iter>=maxiter ) {
			if (errorOccured<=0) {
				errorOccured = 1;
				sprintf(errorString,"maximum number of event iterations reached (%li) at t=%f",(long)iter,t);
			}
			return(-1);
		}

		/* Update index-1 equations */
		if(!failskip && NIX1>0) {
			fp(NEQ,t,y,yp);
			if( IS_UNDEF(yp[0]) ) {
				if (errorOccured<=0) {
					errorOccured = 1;
					sprintf(errorString,"index-1 and derivative evaluation failure on event at t=%f",t);
				}
				return(-2);
			}
		}
		/* Verify that no y values are undefined */
		for(i=0;i<NEQ;i++)
			if(IS_UNDEF(y[i])) {
				if (errorOccured<=0) {
					errorOccured = 1;
					sprintf(errorString,"undefined value encountered during execution of RunEvents at t=%f",t);
				}
				return(-4);
			}

		/* Update pre */
		for(i=0;i<NEQ;i++) ypre[i]=y[i];
		if(failskip) continue;

		/* Evaluate event triggers, and update modes */
		eev(t,y,ypre,tval);
		flag=CheckEvents(tval,y-1,modes,oldmodes,req,inc,ivl);
		if(flag<0) {
			if (errorOccured<=0) {
				errorOccured = 1;
				sprintf(errorString,"internal error: bad event at t=%f",t);
			}
			return(-5);
		}
	}
	return(0);
}

static void SolverUpdate(SolverStruct *S, int synced, int commit)
{
	UNUSED(commit);
	if( synced ) return;
	fp(NEQ,S->w[0],&S->w[1],&S->w[NEQ+NPAR+1]);
	if(IS_UNDEF(S->w[NEQ+NPAR+1])) {
		SolverError(S->w[0],0,"index-1 and derivative evaluation failure");
		return;
	}
	otp(S->w[0],&S->w[1],&S->w[NEQ+NPAR+1]);
}

static int SolverProject(SolverStruct *S)
{
	int i;

	UNUSED(S);
	i=RunEvents(S->w,S->iw,0,18,EVTITER,S->psto);
	if(i) return(i);
	return(0);
}

static void SolverOutputs(SolverStruct *S)
{
	otp(S->w[0],&S->w[1],&S->w[NEQ+NPAR+1]);
}


#define MAXSTEP 10000
#define ABSTOLRAT 1e-4
#define ULP1 4.4e-16

void ck45coeffs(
	double *a,	/* Storage for a coeffs */
	double *b,	/* Storage for b coeffs */
	double *c,	/* Storage for c coeffs */
	double *dc	/* Storage for dc coeffs */
)
{
	a[0] = 1./5.;
	a[1] = 3./10.;
	a[2] = 3./5.;
	a[3] = 1.;
	a[4] = 7./8.;

	b[0] = 1./5.;
	b[1] = 3./40.;
	b[2] = 9./40.;
	b[3] = 3./10.;
	b[4] = -9./10.;
	b[5] = 6./5.;
	b[6] = -11./54.;
	b[7] = 5./2.;
	b[8] = -70./27.;
	b[9] = 35./27.;
	b[10] = 1631./55296.;
	b[11] = 175./512.;
	b[12] = 575./13824.;
	b[13] = 44275./110592.;
	b[14] = 253./4096.;

	c[0] = 37./378.;
	c[1] = 0.;
	c[2] = 250./621.;
	c[3] = 125./594.;
	c[4] = 0.;
	c[5] = 512./1771.;

	dc[0] = c[0]-2825./27648.;
	dc[1] = 0.;
	dc[2] = c[2]-18575./48384.;
	dc[3] = c[3]-13525./55296.;
	dc[4] = -277./14336.;
	dc[5] = c[5]-1./4.;
}

/* Degree 3 interpolant */
void interp(
	double xi,		/* Interpolation time */
	double xold,	/* Interval start time */
	double x,		/* Interval end time */
	double *yold,	/* Old solution */
	double *y,		/* Current solution */
	double *dyold,	/* Old derivative values */
	double *dy,	/* Current derivative values */
	double *yinterp/* Computed interp. values */
)
{
	int i;
	double h,tau1,tau2,t1,t2,t3,t4,t5,t6,t7,t8,t9;

	h=x-xold;
	tau1=xi-xold;
	tau2=x-xi;

	t1=h*h*h;
	t1=1.0/t1;
	t2=h*t1;
	t3=tau1*tau1;
	t4=tau2*tau2;
	t5=t3*(3*tau2+tau1)*t1;
	t6=t4*(tau2+3*tau1)*t1;
	t7=-t3*tau2*t2;
	t8=t4*tau1*t2;
	t9=tau1*h*t2;

	for(i=0;i<NDIFF;i++)
		yinterp[i]=t5*y[i]+t6*yold[i]+t7*dy[i]+t8*dyold[i];
	/* Linear approx. for ix1 vars */
	for(i=NDIFF;i<NDIFF+NIX1;i++)
		yinterp[i]=y[i]+t9*(y[i]-yold[i]);
	/* Copy old values for discretes */
	for(i=NDIFF+NIX1;i<NEQ+NPAR;i++)
		yinterp[i]=yold[i];
}

#if NEVT>0
/* Modified bisection root-finder for event detection */
double findroot(
	double x0,			/* Interval start time */
	double x1,			/* Interval end time */
	double *y0,		/* Old solution */
	double *y1,		/* Current solution */
	double *dy0,		/* Old derivative values */
	double *dy1,		/* Current derivative values */
	double ye0,		/* Old event value */
	double ye1,		/* Current event value */
	int evti,		/* Event index */
	double *yinterp,	/* Interpol. storage */
	double *yevtst,	/* Event eval. storage */
	double *ytemp		/* Temp. storage */
)
{
	int i;
	double eps,fac,sl,xh,xl,xm,yem;

	/* Bisection loop */
	xl=x0; xh=x1;
	fac=1.0;
	for(i=0;i<100;i++) {
		sl=ye0-ye1;
		xm=(xh*ye0-xl*ye1)/sl;
		eps=1e-6*(xh-xl);
		if( eps<1.5*fac*ULP1*fabs(xm) ) eps=1.5*fac*ULP1*fabs(xm);
		if( xh-xm < xm-xl ) xm-=eps;
		else xm+=eps;
		interp(xm,x0,x1,y0,y1,dy0,dy1,yinterp);
#if NIX1>0
		fp(NEQ,xm,yinterp,ytemp);
		if(IS_UNDEF(ytemp[0])) {
			SolverError(x0,1,"index-1 and derivative evaluation failure");
			return(-1);
		}
#endif
		eev(xm,yinterp,yinterp,yevtst);
		yem=yevtst[evti];
		if( yem*ye0==0.0 ) {
			fac=fac*2.0;
		}
		else if( yem*ye0>0.0 ) {
			/* We're on the left */
			fac=1.0;
			xl=xm;
			ye0=yem;
		}
		else {
			fac=1.0;
			xh=xm;
			ye1=yem;
		}
		/* Termination criteria */
		if( xh-xl<4.00001*fac*ULP1*fabs(xh) ) return(xh);
	}
	SolverError(x0,1,"event detection error");
	return(*dsn_undef);
}
#endif

/* Main integration routine */
int Integrate(
	double *w,		/* Initial solution */
	M_INT *iw,	/* Event modes */
	double xend,	/* End time */
	double tol,	/* Tolerance limit for iteration */
	double *hinit	/* Initial stepsize */
)
{
	int i,nstep,numstep,halfnsteps,fixedstep,last;
	double *y,yold[NEQ+NPAR],dy[NDFA],yerr[NEQ+NPAR],yscal[NDFA],ytemp[NEQ+NPAR],
			a[5],b[15],c[6],dc[6],
			ak0[NDIFF],ak1[NDIFF],ak2[NDIFF],ak3[NDIFF],ak4[NDIFF],
			eps,errmax,h,hnext,htemp,x,xnew,xstart,xhalf,
			SAFETY,PGROW,PSHRNK,SHRNK,ERRCON;
#if NEVT>0
  #if NCON>0
	double yproj[NCON*(1+NDIFF+2*NCON)];
	int change;
  #else
	double *yproj=NULL;
  #endif
	double dyold[NDFA],yevt[NEVT],yevtold[NEVT],yevtst[NEVT],yinterp[NEQ+NPAR];
	double evtpt,pt,xold;
	int evti,numevt=0;
#else
  #if NCON>0
	double yproj[NCON*(1+NDIFF+2*NCON)];
	int change;
  #endif
#endif
	/* Transfer data */
	xstart=w[0];
	y=&w[1];
	xhalf=(xend+xstart)/2;
	numstep=0;
	fixedstep=0;
	last=0;
	halfnsteps=(MAXINTSTEP>0) ? (MAXINTSTEP+1)/2 : 0;
	/* Don't allow for backward integration */
	if( (xend-xstart)<0. || *hinit<0. ) {
		SolverError(xstart,1,"backward integration is not supported");
		return(-1);
	}
	x=xstart;
	h=*hinit;
	/* Get the method coefficients */
	ck45coeffs(a,b,c,dc);
	SAFETY=0.9;
	PGROW=-0.2;
	PSHRNK=-0.25;
	SHRNK=0.1;
	ERRCON=1.85e-2;

	for(nstep=0;nstep<MAXSTEP;nstep++) {
		/* Populate derivative vector */
		fp(NEQ,x,y,dy);
		if(IS_UNDEF(dy[0])) {
			SolverError(x,1,"index-1 and derivative evaluation failure");
			return(-1);
		}
		/* Make copies at start of integration step */
#if NEVT>0
		xold=x;
		for(i=0;i<NDIFF;i++) dyold[i]=dy[i];
#endif
		for(i=0;i<NEQ+NPAR;i++) yold[i]=y[i];
		for(i=NDIFF;i<NEQ+NPAR;i++) ytemp[i]=y[i];
		/* Decrease stepsize if it overshoots */
		if( x+h>xend ) {
			last=1;
			h=xend-x;
			if( x+h<xend ) {
				if(h>0.) {
					eps=1e-16*h;
					while( x+h<xend ) {
						h += eps;
						eps *= 2.;
					}
				}
				else h=ULP1*xend;
			}
		}
		else if( xend-x-h < h/1000. ) {
			h=xend-x+ULP1;
		}
		for(i=0;i<NDIFF;i++)
			yscal[i] = fabs(y[i])+fabs(dy[i]*h)+ABSTOLRAT;
		/* Take a step */
		while(1) {
			/* Compute the stages */
			/* Stage 1 */
			for(i=0;i<NDIFF;i++)
				ytemp[i] = yold[i]+h*b[0]*dy[i];
			/* Stage 2 */
			fp(NEQ, x+a[0]*h, ytemp, ak0);
			if(IS_UNDEF(ak0[0])) {
				SolverError(x,1,"index-1 and derivative evaluation failure");
				return(-1);
			}
			for(i=0;i<NDIFF;i++)
				ytemp[i] = yold[i]+h*(b[1]*dy[i]+b[2]*ak0[i]);
			/* Stage 3 */
			fp(NEQ, x+a[1]*h, ytemp, ak1);
			if(IS_UNDEF(ak1[0])) {
				SolverError(x,1,"index-1 and derivative evaluation failure");
				return(-1);
			}
			for(i=0;i<NDIFF;i++)
				ytemp[i] = yold[i]+h*(b[3]*dy[i]+b[4]*ak0[i]+b[5]*ak1[i]);
			/* Stage 4 */
			fp(NEQ, x+a[2]*h, ytemp, ak2);
			if(IS_UNDEF(ak2[0])) {
				SolverError(x,1,"index-1 and derivative evaluation failure");
				return(-1);
			}
			for(i=0;i<NDIFF;i++)
				ytemp[i] = yold[i]+h*(b[6]*dy[i]+b[7]*ak0[i]+b[8]*ak1[i]+b[9]*ak2[i]);
			/* Stage 5 */
			fp(NEQ, x+a[3]*h, ytemp, ak3);
			if(IS_UNDEF(ak3[0])) {
				SolverError(x,1,"index-1 and derivative evaluation failure");
				return(-1);
			}
			for(i=0;i<NDIFF;i++)
				ytemp[i] = yold[i]+h*(b[10]*dy[i]+b[11]*ak0[i]+b[12]*ak1[i]+b[13]*ak2[i]+b[14]*ak3[i]);
			/* Stage 6 */
			fp(NEQ, x+a[4]*h, ytemp, ak4);
			if(IS_UNDEF(ak4[0])) {
				SolverError(x,1,"index-1 and derivative evaluation failure");
				return(-1);
			}
			for(i=0;i<NDIFF;i++)
				y[i] = yold[i]+h*(c[0]*dy[i]+c[1]*ak0[i]+c[2]*ak1[i]+c[3]*ak2[i]+c[4]*ak3[i]+c[5]*ak4[i]);
			/* Error estimate */
			for(i=0;i<NDIFF;i++)
				yerr[i] = h*(dc[0]*dy[i]+dc[1]*ak0[i]+dc[2]*ak1[i]+dc[3]*ak2[i]+dc[4]*ak3[i]+dc[5]*ak4[i]);

			numstep++;
			if( MAXINTSTEP>0 && !fixedstep ) {
				if(numstep>halfnsteps && x<xhalf) {
					/* We're not half-way through integration but have used up
					more than half of the allowed integration points, go fixed-step */
					h=(xend-x)/halfnsteps;
					hnext=h;
					fixedstep=1;
					SolverWarning(x,"Integrator has reached the specified integration step limit");
				}
			}
			if(fixedstep) break;
			errmax=0.0;
			for(i=0;i<NDIFF;i++) errmax=max(errmax,fabs(yerr[i]/yscal[i]));
			errmax /= tol;
			if( errmax<=1.0 ) break;
			htemp=SAFETY*h*pow(errmax,PSHRNK);
			/* Truncation error too large, reduce stepsize */
			h=max(htemp,SHRNK*h);
			xnew=x+h;
			if( xnew==x ) {
				SolverError(x,1,"stepsize underflow in integrate");
				return(-1);
			}
		}
		if(!fixedstep) {
			if( errmax>ERRCON ) hnext=SAFETY*h*pow(errmax,PGROW);
			else hnext=2.0*h;
			if(!last) *hinit=hnext;
		}
		x += h;
		w[0]=x;
#if NEVT>0
		if( MAXNEVT==0 || numevt<MAXNEVT ) {
			fp(NEQ,x,y,dy);
			if(IS_UNDEF(dy[0])) {
				SolverError(x,1,"index-1 and derivative evaluation failure");
				return(-1);
			}
			/* Do event detection with interpolation */
			eev(xold,yold,yold,yevtold);
			eev(x,y,y,yevt);
			evtpt=x+0.1;
			evti=NEVT+1;
			for(i=0;i<NEVT;i++) {
				if( yevt[i]*yevtold[i]<0.0 ||
					(yevtold[i]==0.0 && yevt[i]!=0.0) ) {
					/* Root is bracketed between xold and x */
					pt=findroot(xold,x,yold,y,dyold,dy,yevtold[i],yevt[i],i,yinterp,yevtst,ytemp);
					if(IS_UNDEF(pt)) {
						SolverError(x,1,"event point detection failure");
						return(-1);
					}
					if( pt<evtpt ) {
						evtpt=pt;
						evti=i;
					}
				}
			}
			if( evti<=NEVT ) {
				x=evtpt;
				w[0]=x;
				interp(x,xold,x,yold,y,dyold,dy,yinterp);
				for(i=0;i<NEQ+NPAR;i++) y[i]=yinterp[i];
				fp(NEQ,x,y,dy);
				if(IS_UNDEF(dy[0])) {
					SolverError(x,1,"index-1 and derivative evaluation failure");
					return(-1);
				}
				i=RunEvents(w,iw,0,18,EVTITER,yproj);
				if(i>0 || i<0) {
					SolverError(x,1,"event failure");
					return(-1);
				}
				numevt++;
			}
		}
		if( MAXNEVT>0 && MAXNEVT <= numevt)
			SolverWarning(x,"Integrator has reached the specified event limit");
#endif
#if NCON>0
		/* Perform projection step */
		for(i=0;i<NDIFF+NIX1;i++) ytemp[i]=y[i];
		i=Projection(x,y,CONTOL,CONITER,NULL,yproj);
		if(i>0 && i!=3) {
			SolverError(x,1,"constraint projection failure");
			return(-1);
		}
#endif
		/* Are we done? */
		if( x>=xend ) {
			fp(NEQ,x,y,dy);
			if(IS_UNDEF(dy[0])) {
				SolverError(x,1,"index-1 and derivative evaluation failure");
				return(-1);
			}
			return(1);
		}
		h=hnext;
	}
	SolverError(x,1,"too many steps in integrate");
	return(-1);
}

static void SolverSetup(SolverStruct *S)
{
	int i;

	S->w[0] =  0.00000000000000000e+00;
	S->w[1] =  0.00000000000000000e+00;
	S->w[2] =  2.20000000000000020e+00;
	S->w[3] =  2.20000000000000020e+00;
	S->w[4] =  2.20000000000000020e+00;
	S->w[5] =  2.20000000000000020e+00;
	S->w[6] =  2.20000000000000020e+00;
	S->w[7] =  2.20000000000000020e+00;
	S->w[8] = -2.19999999093092400e+00;
	S->w[9] =  2.20000000000000020e+00;
	S->w[10] =  1.00000000000000000e+00;
	S->w[11] =  1.00000000000000000e+00;
	S->w[12] =  1.00000000000000000e+00;
	S->w[13] =  5.00000000000000000e+00;
	S->w[14] =  6.00000000000000000e+00;
	S->w[15] =  7.00000000000000000e+00;
	S->w[16] =  8.00000000000000000e+00;
	S->w[17] =  9.00000000000000000e+00;
	S->w[18] =  1.00000000000000000e+00;
	S->w[19] =  0.00000000000000000e+00;
	S->w[20] =  1.00000000000000000e+00;
	S->w[21] =  0.00000000000000000e+00;
	S->w[22] =  6.00000000000000020e-06;
	S->w[23] =  9.70000000000000030e-06;
	S->w[24] =  1.80000000000000000e-05;
	for(i=0;i<NDIFF;i++) S->w[i+NEQ+NPAR+1]=0.0;
	S->iw[2*NEVT+0] = 0; S->iw[3*NEVT+0] = 20; S->iw[4*NEVT+0] = 0;
	S->iw[2*NEVT+1] = 0; S->iw[3*NEVT+1] = 21; S->iw[4*NEVT+1] = 0;
	eev(S->w[0],&S->w[1],&S->w[1],&S->w[2*NEQ+NPAR+NDFA+1]);
	InitEventModes(&S->w[2*NEQ+NPAR+NDFA+1],&S->w[1],S->iw,&S->iw[3*NEVT],&S->iw[2*NEVT]);
}

static void SolverInitialize(SolverStruct *S)
{
	int i;

	UNUSED(i);
	eev(S->w[0],&S->w[1],&S->w[1],&S->w[2*NEQ+NPAR+NDFA+1]);
	i=RunEvents(S->w,S->iw,2,18,EVTITER,S->psto);
	if (i<0) {
		SolverError(S->w[0],0,"error running events");
		return;
	}
	else if (i>0) {
		SolverError(S->w[0],1,"error running events");
		return;
	}
	i=cpr(S->w[0],&S->w[1]);
	S->w[NEQ+NPAR+1]=0.0;
	fp(NEQ,S->w[0],&S->w[1],&S->w[NEQ+NPAR+1]);
	if(IS_UNDEF(S->w[NEQ+NPAR+1])) {
		SolverError(S->w[0],0,"index-1 and derivative evaluation failure");
		return;
	}
	i=RunEvents(S->w,S->iw,0,18,EVTITER,S->psto);
	if (i<0) {
		SolverError(S->w[0],0,"error running events");
		return;
	}
	else if (i>0) {
		SolverError(S->w[0],1,"error running events");
		return;
	}
	SolverOutputs(S);
}

/*****************************************************************************/
/* FILE fmuTemplate.c */
/*****************************************************************************/


#define FMI2_COSIMULATION
#define MODEL_GUID "{109548b5-239f-3ac1-df5f-fac3ac435a17}"
#ifndef DISABLE_PREFIX
    #define FMI2_FUNCTION_PREFIX OilPump_
#endif



/* define model size */
#define NUMBER_OF_REALS 49
#define NUMBER_OF_INTEGERS 5*NEVT
#define NUMBER_OF_BOOLEANS 0
#define NUMBER_OF_STRINGS 1

/* include FMU header files, typedefs and macros */
#include "fmuTemplate.h"

/* define initial state vector and derivative vector as vectors of value references */
#define STATES {1}
#define DERS   {25}
#define OUTS   {9, 8}

#ifdef FMI2_PROVIDES_DERIVATIVES
#define NIKNO 0
#define NIUNK 0
#define IKNOS { }
#define IUNKS { }
#endif

/*****************************************************************************/

#if NDIFF>0
fmi2ValueReference vrStates[NDIFF] = STATES;
fmi2ValueReference   vrDers[NDIFF] = DERS;
#else
fmi2ValueReference *vrStates = NULL;
fmi2ValueReference   *vrDers = NULL;
#endif

#if NOUT>0
fmi2ValueReference   vrOuts[NOUT] = OUTS;
#else
fmi2ValueReference   *vrOuts = NULL;
#endif

#ifdef FMI2_PROVIDES_DERIVATIVES
#if NIKNO>0
fmi2ValueReference   vrIknowns[NIKNO] = IKNOS;
#else
fmi2ValueReference   *vrIknowns = NULL;
#endif
#if NIUNK>0
fmi2ValueReference   vrIunknowns[NIUNK] = IUNKS;
#else
fmi2ValueReference   *vrIunknowns = NULL;
#endif
#endif

/*****************************************************************************
 * BEGIN: Private functions
 *****************************************************************************/
/*****************************************************************************/
static fmi2Boolean invalidNumber(ModelInstance*	comp,
								 const char*	f,
								 const char*	arg,
								 int			n,
								 int			nExpected) {
	if (n != nExpected) {
		comp->state = modelError;
		compLog(compEnv, comp->instanceName, fmi2Error,
			"error", "[%s]: Invalid argument %s = %d. Expected %d.",
			f, arg, n, nExpected);
		return fmi2True;
	}
	return fmi2False;
}
/*****************************************************************************/
static fmi2Boolean invalidState(ModelInstance*	comp,
								const char*		f,
								int				statesExpected) {
	if (!comp) return fmi2True;
	if (!(comp->state && statesExpected)) {
		comp->state = modelError;
		compLog(compEnv, comp->instanceName, fmi2Error,
			"error", "[%s]: Illegal call sequence.", f);
		return fmi2True;
	}
	return fmi2False;
}
/*****************************************************************************/
static fmi2Boolean nullPointer(	ModelInstance*	comp,
								const char*		f,
								const char*		arg,
								const void*		p) {
	if (!p) {
		comp->state = modelError;
		compLog(compEnv, comp->instanceName, fmi2Error,
			"error", "[%s]: Invalid argument %s = NULL.", f, arg);
		return fmi2True;
	}
	return fmi2False;
}
/*****************************************************************************/
static fmi2Boolean vrOutOfRange(ModelInstance*		comp,
								const char*			f,
								fmi2ValueReference	vr,
								int					end) {
	if ((int)vr >= end) {
		comp->state = modelError;
		compLog(compEnv, comp->instanceName, fmi2Error,
			"error", "[%s]: Illegal value reference %u.", f, vr);
		return fmi2True;
	}
	return fmi2False;
}
/*****************************************************************************/
void logMessage(ModelInstance*	comp,
				const char*		f,
				const char*		e,
				fmi2Status		value) {
	compLog(compEnv, comp->instanceName, value,
			e, "[%s]: %s", f, errorString);
}
/*****************************************************************************/
void logWarning(ModelInstance*	comp,
				const char*		f,
				const char*		e,
				fmi2Status		value) {
	compLog(compEnv, comp->instanceName, value,
			e, "[%s]: %s", f, warningString);
}
/*****************************************************************************/
static void setVidError(ModelInstance *comp, char *errstr)
{
	if (errstr)
		strcpy(comp->viderror,errstr);
	else if (errorOccured)
		strcpy(comp->viderror,errorString);
	else
		strcpy(comp->viderror,"unknown error");
	comp->vidsts = -1;
}
/*****************************************************************************/
fmi2Status syncModel(ModelInstance *c, const char *f)
{
	ModelInstance* comp = (ModelInstance *)c;
	int i;

	if (comp->state==modelInitialized && !comp->synced) {
		if(comp->initializeMode) {
			if(comp->S.wset) {
				SolverSetup(&(comp->S));
				for(i=0;i<NUMBER_OF_REALS;i++)
					if(!IS_UNDEF(comp->S.wset[i]))
						comp->S.w[i]=comp->S.wset[i];
			}
			SolverInitialize(&(comp->S));
			if (errorOccured>0) {
				setVidError(comp,NULL);
				if (comp->fptr) {
					writeErrorToFile(comp->fptr, NULL);
					comp->fptr = NULL;
				}
				comp->state = modelTerminated;
				logMessage(comp, f, "error", fmi2Error);
				return fmi2Error;
			}
			else if(errorOccured<0) {
				logMessage(comp, f, "warning", fmi2Warning);
				errorOccured=0;
			}
		}
		else {
			if(comp->fmuType==fmi2ModelExchange && comp->S.wset)
				for(i=NDIFF+1;i<=NDIFF+NIX1-NINP-NINPD;i++)
					comp->S.w[i]=comp->S.wset[i];
			SolverUpdate(&(comp->S),0,0);
			if(errorOccured>0) {
				setVidError(comp,NULL);
				if (comp->fptr) {
					writeErrorToFile(comp->fptr,NULL);
					comp->fptr = NULL;
				}
				errorOccured=0;
				logMessage(comp, f, "error", fmi2Error);
				return fmi2Discard;
			}
			else if(errorOccured<0) {
				logMessage(comp, f, "warning", fmi2Warning);
				errorOccured=0;
			}
		}
		if(inputchange) inputchange=0;
		comp->synced = fmi2True;
		comp->jsynced = fmi2False;
	}
	return fmi2OK;
}

/*****************************************************************************
 * END: Private functions
 *****************************************************************************/
/*****************************************************************************
 * Common functions: for FMI Model Exchange 2.0 and for FMI Co-Simulation 2.0
 *****************************************************************************/
/*****************************************************************************/
/* BEGIN: fmi2GetTypesPlatform */
const char* fmi2GetTypesPlatform() {
	return fmi2TypesPlatform;
}
/* END: fmi2GetTypesPlatform */
/*****************************************************************************/

/*****************************************************************************/
/* BEGIN: fmi2GetVersion */
const char* fmi2GetVersion() {
	return fmi2Version;
}
/* END: fmi2GetVersion */
/*****************************************************************************/

/*****************************************************************************/
/* BEGIN: fmi2SetDebugLogging */
fmi2Status fmi2SetDebugLogging(	fmi2Component	c,
								fmi2Boolean		loggingOn,
								size_t			nCategories,
								const fmi2String categories[]) {
	ModelInstance* comp = (ModelInstance *)c;

	if (invalidState(comp, "fmi2SetDebugLogging", not_modelError))
		return fmi2Error;
	if (comp->loggingOn)
		compLog(compEnv, comp->instanceName, fmi2OK,
			"log", "fmi2SetDebugLogging: loggingOn = %d", loggingOn);
	if(nCategories>0 && categories!=NULL)
		/* No support for separate logging categories at this time */
		comp->loggingOn = fmi2True;
	else
		comp->loggingOn = loggingOn;
	return fmi2OK;
}
/* END: fmi2SetDebugLogging */
/*****************************************************************************/

static char nameME[] = "ModelExchange";
static char nameCS[] = "CoSimulation";
static char binfile[] = "DISABLED";

/*****************************************************************************/
/* BEGIN: fmi2Instantiate */
fmi2Component fmi2Instantiate(	fmi2String					instanceName,
								fmi2Type					fmuType,
								fmi2String					GUID,
								fmi2String					fmuLocation,
								const fmi2CallbackFunctions* functions,
								fmi2Boolean					visible,
								fmi2Boolean					loggingOn) {
	ModelInstance* comp;
	char * fname;
	fmi2String iname;
	int i;

	UNUSED(fmuLocation);
	UNUSED(visible);
	if (fmuType==fmi2ModelExchange)
		fname = nameME;
	else
		fname = nameCS;

	if (!functions->logger)
		return NULL;
	if (!functions->allocateMemory || !functions->freeMemory) {
		functions->logger(NULL, instanceName, fmi2Error,
				"error", "[%s]: Callback function is not found.", fname);
		return NULL;
	}
	if (!instanceName || strlen(instanceName)==0) {
		functions->logger(NULL, instanceName, fmi2Error,
				"error", "[%s]: Instance name is not found.", fname);
		return NULL;
	}
	if (strcmp(GUID, MODEL_GUID)) {
		functions->logger(NULL, instanceName, fmi2Error,
				"error", "[%s]: Inconsistent GUID %s. Expected %s.",
				fname, GUID, MODEL_GUID);
		return NULL;
	}

	comp = (ModelInstance *)functions->allocateMemory(1,sizeof(ModelInstance));

	iname = functions->allocateMemory(strlen((char*)instanceName) + 1,sizeof(char));
	if (!iname)
		functions->logger(NULL, instanceName, fmi2Error,
				"error", "[%s]: Cannot allocate memory.", fname);
	strcpy((char*)iname, (char*)instanceName);

	if (comp) {
		comp->S.w = functions->allocateMemory(NUMBER_OF_REALS,sizeof(fmi2Real));
		if (fmuType==fmi2ModelExchange)
			comp->S.wset = functions->allocateMemory(NUMBER_OF_REALS,sizeof(fmi2Real));
		else
			comp->S.wset = NULL;
		if(NCON>0)
			comp->S.psto = functions->allocateMemory(NDIFF*(1+NCON+2*NDIFF),sizeof(fmi2Real));
		else
			comp->S.psto = NULL;
		if(SSTO>0)
			comp->S.ssto = functions->allocateMemory(NDFA*(NDFA+1),sizeof(fmi2Real));
		else
			comp->S.ssto = NULL;
#ifdef FMI2_PROVIDES_DERIVATIVES
		if( (1+NDIFF+NINP)*(NDIFF+NOUT)>0 ) {
			comp->Jacobian = functions->allocateMemory((1+NDIFF+NINP)*(NDIFF+NOUT),sizeof(fmi2Real));
			if (!comp->Jacobian) {
				functions->logger(NULL, instanceName, fmi2Error,
						"error", "[%s]: Cannot allocate memory.", fname);
				return NULL;
			}
		}
		else
			comp->Jacobian = NULL;

		if( NIUNK*NIKNO>0 ) {
			comp->initJacobian = functions->allocateMemory(NIUNK*NIKNO,sizeof(fmi2Real));
			if (!comp->initJacobian) {
				functions->logger(NULL, instanceName, fmi2Error,
						"error", "[%s]: Cannot allocate memory.", fname);
				return NULL;
			}
		}
		else
			comp->initJacobian = NULL;

		if( NIUNK>0 ) {
			comp->initRes = functions->allocateMemory(NIUNK,sizeof(fmi2Real));
			if (!comp->initRes) {
				functions->logger(NULL, instanceName, fmi2Error,
						"error", "[%s]: Cannot allocate memory.", fname);
				return NULL;
			}
		}
		else
			comp->initRes = NULL;

#else
		comp->Jacobian = NULL;
		comp->initJacobian = NULL;
		comp->initRes = NULL;
#endif
		if (NUMBER_OF_INTEGERS > 0)
			comp->S.iw = functions->allocateMemory(NUMBER_OF_INTEGERS,sizeof(M_INT));
		else
			comp->S.iw = NULL;
		if (NUMBER_OF_BOOLEANS > 0)
			comp->b = functions->allocateMemory(NUMBER_OF_BOOLEANS,sizeof(fmi2Boolean));
		else
			comp->b = NULL;
		if (NUMBER_OF_STRINGS > 0) {
			comp->s = functions->allocateMemory(NUMBER_OF_STRINGS,sizeof(fmi2String));
			for (i=0; i<NUMBER_OF_STRINGS; i++)
				comp->s[i] = NULL;
		}
		else
			comp->s = NULL;
	}

	if (!comp || !comp->S.w ||	(NUMBER_OF_INTEGERS>0 && !comp->S.iw ) ||
								(NUMBER_OF_BOOLEANS>0 && !comp->b) ||
								(NUMBER_OF_STRINGS>0  && !comp->s)) {
		functions->logger(NULL, instanceName, fmi2Error,
				"error", "[%s]: Cannot allocate memory.", fname);
		return NULL;
	}

	comp->instanceName	= iname;
	comp->GUID			= MODEL_GUID;
	comp->fmuType		= fmuType;
	memcpy(&comp->functions,functions,sizeof(fmi2CallbackFunctions));
	comp->loggingOn		= loggingOn;

	if(comp->S.wset) {
		for(i=0;i<NUMBER_OF_REALS;i++)
			comp->S.wset[i]=1.0/dsn_zero;
		comp->synced			= fmi2False;
		comp->jsynced			= fmi2False;
	}
	else {
		SolverSetup(&(comp->S));
		comp->synced			= fmi2True;
		comp->jsynced			= fmi2True;
	}

	comp->initializeMode	= fmi2False;
	comp->state				= modelInstantiated;
	comp->vidsts			= 0;
	comp->minSampleStep	= minsamplestep;
	comp->fptr				= NULL;
	if (strcmp(binfile,"DISABLED") == 0)
		comp->fstr = NULL;
	else {
		comp->fstr = binfile;
		comp->s[0] = comp->functions.allocateMemory(1+strlen(binfile),sizeof(char));
		strcpy((char*)comp->s[0],(char*)binfile);
	}

	if (comp->loggingOn)
		compLog(compEnv, instanceName, fmi2OK,
			"log", "[%s]: GUID = %s", fname, GUID);

	return comp;
}
/* END: fmi2Instantiate */
/*****************************************************************************/

/*****************************************************************************/
/* BEGIN: fmi2FreeInstance */
/*****************************************************************************/
void fmi2FreeInstance(fmi2Component c) {
	int i;
	ModelInstance* comp = (ModelInstance *)c;

	if (!comp) return;

	if (comp->loggingOn)
		compLog(compEnv, comp->instanceName, fmi2OK,
			"log", "fmi2FreeInstance");

	if (comp->instanceName)	comp->functions.freeMemory((char*)comp->instanceName);
	if (comp->S.w)			comp->functions.freeMemory(comp->S.w);
	if (comp->S.iw)			comp->functions.freeMemory(comp->S.iw);
	if (comp->S.wset)			comp->functions.freeMemory(comp->S.wset);
	if (comp->S.psto)			comp->functions.freeMemory(comp->S.psto);
	if (comp->S.ssto)			comp->functions.freeMemory(comp->S.ssto);
	if (comp->b)			comp->functions.freeMemory(comp->b);
	if (comp->Jacobian)		comp->functions.freeMemory(comp->Jacobian);
	if (comp->initRes)		comp->functions.freeMemory(comp->initRes);
	if (comp->initJacobian)		comp->functions.freeMemory(comp->initJacobian);
	if (comp->s) {
		for (i=0; i<NUMBER_OF_STRINGS; i++)
			if (comp->s[i]) comp->functions.freeMemory((char*)comp->s[i]);
		comp->functions.freeMemory((char*)comp->s);
	}

	comp->functions.freeMemory(comp);
}
/* END: fmi2FreeInstance */
/*****************************************************************************/

/*****************************************************************************/
/* BEGIN: fmi2SetupExperiment */
/*****************************************************************************/
fmi2Status fmi2SetupExperiment(	fmi2Component	c,
								fmi2Boolean		toleranceDefined,
								fmi2Real		tolerance,
								fmi2Real		startTime,
								fmi2Boolean		stopTimeDefined,
								fmi2Real		stopTime) {
	ModelInstance* comp = (ModelInstance *)c;

	UNUSED(toleranceDefined);
	UNUSED(tolerance);
	comp->S.w[0]	= startTime;
	comp->startTime	= startTime;

	if (stopTimeDefined)
		comp->stopTime = stopTime;
	else
		comp->stopTime = 0.0;

	comp->stopTimeDefined = stopTimeDefined;

	if (comp->fptr) {
		fclose(comp->fptr);
		comp->fptr = NULL;
	}
	if (comp->fstr && strcmp(comp->fstr,"DISABLED")!=0
						&& strcmp(comp->fstr,"'DISABLED'")!=0 )
		comp->fptr = fopen(comp->fstr,"wb");

	comp->lastsampletime = -1e10;
	comp->lastStepSize = -1.0;
	comp->lastSuccessfulTime = startTime;
	comp->numpts = 0;
	comp->vidsts = 0;
	comp->vidlasttime = -1e10;

	return fmi2OK;
}
/* END: fmi2SetupExperiment */
/*****************************************************************************/

/*****************************************************************************/
/* BEGIN: fmi2EnterInitializationMode */
fmi2Status fmi2EnterInitializationMode(fmi2Component c) {
	ModelInstance* comp = (ModelInstance *)c;

	if (invalidState(comp, "fmi2EnterInitializationMode", modelInstantiated))
		return fmi2Error;
	if (comp->loggingOn)
		compLog(compEnv, comp->instanceName, fmi2OK,
			"log", "fmi2EnterInitializationMode");

	/* Do not sync here - delay the sync until the first FMU query */
	comp->synced			= fmi2False;
	comp->jsynced			= fmi2False;

	comp->initializeMode	= fmi2True;
	comp->state				= modelInitialized;
	comp->vidsts			= 1;
	if (comp->fptr) {
		fwrite(nData,sizeof(fmi2Real),2,comp->fptr);
		if(NPAR>0) {
			syncModel(c,"fmi2EnterInitializationMode");
			fwrite(&comp->S.w[NEQ+1],sizeof(fmi2Real),NPAR,comp->fptr);
		}
	}

	return fmi2OK;
}
/* END: fmi2EnterInitializationMode */
/*****************************************************************************/

/*****************************************************************************/
/* BEGIN: fmi2ExitInitializationMode */
fmi2Status fmi2ExitInitializationMode(fmi2Component c) {
	ModelInstance* comp = (ModelInstance *)c;
	fmi2Status sts;
	int i;

	if (comp) {
		sts = syncModel(c,"fmi2ExitInitializationMode");
		if ( sts!=fmi2OK ) return(sts);
		comp->initializeMode = fmi2False;
		if(comp->fmuType==fmi2ModelExchange && comp->S.wset)
			for(i=NDIFF+1;i<=NDIFF+NIX1-NINP;i++)
				comp->S.wset[i]=comp->S.w[i];
		comp->jsynced =fmi2False;
		comp->vidsts = 2;
		if (comp->fptr)
			fwrite(comp->S.w,sizeof(fmi2Real),NEQ+1,comp->fptr);
		return fmi2OK;
	}
	else
		return fmi2Error;
}
/* END: fmi2ExitInitializationMode */
/*****************************************************************************/

/*****************************************************************************/
/* BEGIN: fmi2Terminate */
fmi2Status fmi2Terminate(fmi2Component c) {
	ModelInstance* comp = (ModelInstance *)c;

	if (invalidState(comp, "fmi2Terminate", modelInitialized)) return fmi2Error;
	if (comp->loggingOn)
		compLog(compEnv, comp->instanceName, fmi2OK,
			"log", "fmi2Terminate");
	if (comp->fptr) {
		fclose(comp->fptr);
		comp->fptr = NULL;
	}

	comp->state = modelTerminated;

	return fmi2OK;
}
/* END: fmi2Terminate */
/*****************************************************************************/

/*****************************************************************************/
/* BEGIN: fmi2Reset */
fmi2Status fmi2Reset(fmi2Component c) {
	ModelInstance* comp = (ModelInstance *)c;
	int i;

	if (invalidState(comp, "fmi2Reset", modelInitialized)) return fmi2Error;
	if (comp->loggingOn)
		compLog(compEnv, comp->instanceName, fmi2OK,
			"log", "fmi2Reset");

	comp->state = modelInstantiated;
	comp->synced = fmi2False;
	comp->jsynced = fmi2False;

	if(comp->S.wset)
		for(i=0;i<NUMBER_OF_REALS;i++)
			comp->S.wset[i]=1.0/dsn_zero;
	else
		SolverSetup(&(comp->S));

	return fmi2OK;
}
/* END: fmi2Reset */
/*****************************************************************************/

/*****************************************************************************/
/* BEGIN: fmi2GetReal */
fmi2Status fmi2GetReal(	fmi2Component			c,
						const fmi2ValueReference vr[],
						size_t					nvr,
						fmi2Real				value[]) {
	int i;
	fmi2Status sts;
	ModelInstance* comp = (ModelInstance *)c;

	if (invalidState(comp, "fmi2GetReal", validGet))
		return fmi2Error;
	if (nvr>0 && nullPointer(comp, "fmi2GetReal", "vr[]", vr))
		return fmi2Error;
	if (nvr>0 && nullPointer(comp, "fmi2GetReal", "value[]", value))
		return fmi2Error;

#if NUMBER_OF_REALS+1>0
	/*for (i=0; i<(int)nvr; i++)
		if (vrOutOfRange(comp, "fmi2GetReal", vr[i], NUMBER_OF_REALS))
		return fmi2Error;*/

	if(comp->state != modelTerminated) {
		sts = syncModel(comp,"fmi2GetReal");
		if ( sts!=fmi2OK ) return sts;
	}

	for (i=0; i<(int)nvr; i++) {
		if( nomfac && vr[i]>=vrStates[0] && vr[i]<vrStates[0]+NDIFF )
			value[i] = comp->S.w[vr[i]]/nomfac[vr[i]-vrStates[0]];
		else if( nomfac && vr[i]>=vrDers[0] && vr[i]<vrDers[0]+NDIFF )
			value[i] = comp->S.w[vr[i]]/nomfac[vr[i]-vrDers[0]];
		else if (vr[i] == 49)
			value[i] = comp->minSampleStep;
		else
			value[i] = comp->S.w[vr[i]];
		if (comp->loggingOn)
			compLog(compEnv, comp->instanceName, fmi2OK,
				"log", "fmi2GetReal: #r%u# = %.16g", vr[i], value[i]);
	}
#endif
	return fmi2OK;
}
/* END: fmi2GetReal */
/*****************************************************************************/

/*****************************************************************************/
/* BEGIN: fmi2GetInteger */
fmi2Status fmi2GetInteger(	fmi2Component			c,
							const fmi2ValueReference vr[],
							size_t					nvr,
							fmi2Integer				value[]) {
	int i;
	fmi2Status sts;
	ModelInstance* comp = (ModelInstance *)c;

	if (invalidState(comp, "fmi2GetInteger", validGet))
		return fmi2Error;
	if (nvr>0 && nullPointer(comp, "fmi2GetInteger", "vr[]", vr))
		return fmi2Error;
	if (nvr>0 && nullPointer(comp, "fmi2GetInteger", "value[]", value))
		return fmi2Error;

	if(comp->state != modelTerminated) {
		sts = syncModel(comp,"fmi2GetInteger");
		if ( sts!=fmi2OK ) return sts;
	}

	for (i=0; i<(int)nvr; i++) {
		if (vrOutOfRange(comp, "fmi2GetInteger", vr[i], NUMBER_OF_INTEGERS))
			return fmi2Error;
		value[i] = (fmi2Integer)comp->S.iw[vr[i]];
		if (comp->loggingOn)
			compLog(compEnv, comp->instanceName, fmi2OK,
				"log", "fmi2GetInteger: #i%u# = %d", vr[i], value[i]);
	}
	return fmi2OK;
}
/* END: fmi2GetInteger */
/*****************************************************************************/

/*****************************************************************************/
/* BEGIN: fmi2GetBoolean */
fmi2Status fmi2GetBoolean(	fmi2Component			c,
							const fmi2ValueReference vr[],
							size_t					nvr,
							fmi2Boolean				value[]) {
	int i;
	fmi2Status sts;
	ModelInstance* comp = (ModelInstance *)c;

	if (invalidState(comp, "fmi2GetBoolean", validGet))
		return fmi2Error;
	if (nvr>0 && nullPointer(comp, "fmi2GetBoolean", "vr[]", vr))
		return fmi2Error;
	if (nvr>0 && nullPointer(comp, "fmi2GetBoolean", "value[]", value))
		return fmi2Error;

	if(comp->state != modelTerminated) {
		sts = syncModel(comp,"fmi2GetBoolean");
		if ( sts!=fmi2OK ) return sts;
	}

	for (i=0; i<(int)nvr; i++) {
		if (vrOutOfRange(comp, "fmi2GetBoolean", vr[i], NUMBER_OF_BOOLEANS))
			return fmi2Error;
		value[i] = comp->b[vr[i]];
		if (comp->loggingOn)
			compLog(compEnv, comp->instanceName, fmi2OK,
				"log", "fmi2GetBoolean: #b%u# = %s",vr[i], value[i]? "true":"false");
	}
	return fmi2OK;
}
/* END: fmi2GetBoolean */
/*****************************************************************************/

/*****************************************************************************/
/* BEGIN: fmi2GetString */
fmi2Status fmi2GetString(fmi2Component			c,
						const fmi2ValueReference vr[],
						size_t					nvr,
						fmi2String				value[]) {
	int i;
	fmi2Status sts;
	ModelInstance* comp = (ModelInstance *)c;

	if (invalidState(comp, "fmi2GetString", validGet))
		return fmi2Error;
	if (nvr>0 && nullPointer(comp, "fmi2GetString", "vr[]", vr))
		return fmi2Error;
	if (nvr>0 && nullPointer(comp, "fmi2GetString", "value[]", value))
		return fmi2Error;

	if(comp->state != modelTerminated) {
		sts = syncModel(comp,"fmi2GetString");
		if ( sts!=fmi2OK ) return sts;
	}

	for (i=0; i<(int)nvr; i++) {
		if (vr[i] == 50)
			value[i] = comp->s[0];
		else {
			comp->state = modelError;
			compLog(compEnv, comp->instanceName, fmi2Error,
					"error", "[%s]: Illegal value reference %u.", "fmi2GetString", vr);
			return fmi2Error;
		}
		if (comp->loggingOn)
			compLog(compEnv, comp->instanceName, fmi2OK, "log",
					"fmi2GetString: #s%u# = '%s'", vr[i], value[i]);
	}
	return fmi2OK;
}
/* END: fmi2GetString */
/*****************************************************************************/

/*****************************************************************************/
/* BEGIN: fmi2SetReal */
fmi2Status fmi2SetReal(	fmi2Component			c,
						const fmi2ValueReference vr[],
						size_t					nvr,
						const fmi2Real			value[]) {
	int i;
	ModelInstance* comp = (ModelInstance *)c;
	double scalev;

	if (invalidState(comp, "fmi2SetReal", modelInstantiated|modelInitialized))
		return fmi2Error;
	if (nvr>0 && nullPointer(comp, "fmi2SetReal", "vr[]", vr))
		return fmi2Error;
	if (nvr>0 && nullPointer(comp, "fmi2SetReal", "value[]", value))
		return fmi2Error;
	if (comp->loggingOn)
		compLog(compEnv, comp->instanceName,
				fmi2OK, "log",
				"fmi2SetReal: nvr = %d",
				nvr);

	for (i=0; i<(int)nvr; i++) {
		if (vrOutOfRange(comp, "fmi2SetReal", vr[i], NUMBER_OF_REALS+1))
			return fmi2Error;
		if (comp->loggingOn)
			compLog(compEnv, comp->instanceName,
					fmi2OK, "log",
					"fmi2SetReal: #r%d# = %.16g", vr[i], value[i]);
		if( nomfac && vr[i]>=vrStates[0] && vr[i]<vrStates[0]+NDIFF )
			scalev = nomfac[vr[i]-vrStates[0]]*value[i];
		else if( nomfac && vr[i]>=vrDers[0] && vr[i]<vrDers[0]+NDIFF )
			scalev = nomfac[vr[i]-vrDers[0]]*value[i];
		else if (vr[i] == 49) {
			comp->minSampleStep = value[i];
			continue;
		}
		else
			scalev = value[i];
		if (comp->S.w[vr[i]]!=scalev) {
#if NINP>0
			if(vr[i]>=1+NDIFF+NIX1-NINP && vr[i]<1+NDIFF+NIX1)
				inputchange=1;
#endif
#if NPAR>0
			if(comp->state==modelInitialized && comp->initializeMode==fmi2False
				&& vr[i]>=1+NEQ && vr[i]<=1+NEQ+NPAR) {
				if(pflags[vr[i]-1-NEQ])
					pchange=1;
				else {
					compLog(NULL, comp->instanceName, fmi2Error, "error",
						"fmi2SetReal: attempt to change fixed parameter after initialization.");
					return fmi2Error;
				}
			}
#endif
			comp->S.w[vr[i]] = scalev;
			if(comp->fmuType==fmi2ModelExchange && comp->S.wset)
				comp->S.wset[vr[i]] = scalev;
			comp->synced = fmi2False;
			comp->jsynced = fmi2False;
		}
	}

	return fmi2OK;
}
/* END: fmi2SetReal */
/*****************************************************************************/

/*****************************************************************************/
/* BEGIN: fmi2SetInteger */
fmi2Status fmi2SetInteger(fmi2Component			c,
						const fmi2ValueReference vr[],
						size_t					nvr,
						const fmi2Integer		value[]) {
	int i;
	ModelInstance* comp = (ModelInstance *)c;

	if (invalidState(comp, "fmi2SetInteger", modelInstantiated|modelInitialized))
		return fmi2Error;
	if (nvr>0 && nullPointer(comp, "fmi2SetInteger", "vr[]", vr))
		return fmi2Error;
	if (nvr>0 && nullPointer(comp, "fmi2SetInteger", "value[]", value))
		return fmi2Error;
	if (comp->loggingOn)
		compLog(compEnv, comp->instanceName,
				fmi2OK, "log", "fmi2SetInteger: nvr = %d",
				nvr);

	for (i=0; i<(int)nvr; i++) {
		if (vrOutOfRange(comp, "fmi2SetInteger", vr[i], NUMBER_OF_INTEGERS))
			return fmi2Error;
		if (comp->loggingOn)
			compLog(compEnv, comp->instanceName,
					fmi2OK, "log", "fmi2SetInteger: #i%d# = %d", vr[i], value[i]);
		if (comp->S.iw[vr[i]]!=(M_INT)value[i]) {
			comp->S.iw[vr[i]] = (M_INT)value[i];
			comp->synced = fmi2False;
			comp->jsynced = fmi2False;
		}
	}

	return fmi2OK;
}
/* END: fmi2SetInteger */
/*****************************************************************************/

/*****************************************************************************/
/* BEGIN: fmi2SetBoolean */
fmi2Status fmi2SetBoolean(fmi2Component			c,
						const fmi2ValueReference vr[],
						size_t					nvr,
						const fmi2Boolean		value[]) {
	int i;
	ModelInstance* comp = (ModelInstance *)c;

	if (invalidState(comp, "fmi2SetBoolean", modelInstantiated|modelInitialized))
		return fmi2Error;
	if (nvr>0 && nullPointer(comp, "fmi2SetBoolean", "vr[]", vr))
		return fmi2Error;
	if (nvr>0 && nullPointer(comp, "fmi2SetBoolean", "value[]", value))
		return fmi2Error;
	if (comp->loggingOn)
		compLog(compEnv, comp->instanceName,
				fmi2OK, "log", "fmi2SetBoolean: nvr = %d", nvr);
	for (i=0; i<(int)nvr; i++) {
		if (vrOutOfRange(comp, "fmi2SetBoolean", vr[i], NUMBER_OF_BOOLEANS))
			return fmi2Error;
		if (comp->loggingOn)
			compLog(compEnv, comp->instanceName,
					fmi2OK, "log",
					"fmi2SetBoolean: #b%d# = %s",
					vr[i], value[i] ? "true" : "false");
		if (comp->b[vr[i]]!=value[i]) {
			comp->b[vr[i]] = value[i];
			comp->synced = fmi2False;
			comp->jsynced = fmi2False;
		}
	}

	return fmi2OK;
}
/* END: fmi2SetBoolean */
/*****************************************************************************/

/*****************************************************************************/
/* BEGIN: fmi2SetString */
fmi2Status fmi2SetString(fmi2Component			c,
						const fmi2ValueReference vr[],
						size_t					nvr,
						const fmi2String		value[]) {
	int i;
	ModelInstance* comp = (ModelInstance *)c;

	if (invalidState(comp, "fmi2SetString", modelInstantiated|modelInitialized))
		return fmi2Error;
	if (nvr>0 && nullPointer(comp, "fmi2SetString", "vr[]", vr))
		return fmi2Error;
	if (nvr>0 && nullPointer(comp, "fmi2SetString", "value[]", value))
		return fmi2Error;
	if (comp->loggingOn)
		compLog(compEnv, comp->instanceName,
				fmi2OK, "log", "fmi2SetString: nvr = %d",	nvr);

	for (i=0; i<(int)nvr; i++) {
		char* string = (char*)comp->s[0];
		if (vr[i] != 50) {
			comp->state = modelError;
			compLog(compEnv, comp->instanceName, fmi2Error,
					"error", "[%s]: Illegal value reference %u.", "fmi2SetString", vr);
			return fmi2Error;
		}
		if (comp->loggingOn)
			compLog(compEnv, comp->instanceName,
					fmi2OK, "log",
					"fmi2SetString: #s%d# = '%s'",
					vr[i], value[i]);
		if (nullPointer(comp, "fmi2SetString", "value[i]", value[i]))
			return fmi2Error;
		if (string==NULL || strlen(string) < strlen(value[i])) {
			if (string) comp->functions.freeMemory(string);
			comp->s[0] = comp->functions.allocateMemory(1+strlen(value[i]),
															sizeof(char));
			if (!comp->s[0]) {
				comp->state = modelError;
				compLog(NULL, comp->instanceName,
						fmi2Error, "error", "fmi2SetString: Out of memory.");
				return fmi2Error;
			}
		}
		strcpy((char*)comp->s[0], (char*)value[i]);
		/*comp->synced = fmi2False;*/
		if (vr[i] == 50)
			comp->fstr = comp->s[0];
	}

	return fmi2OK;
}
/* END: fmi2SetString */
/*****************************************************************************/

/*****************************************************************************/
/* BEGIN: fmi2GetFMUstate */
/*****************************************************************************/
/* Storage structure:
		State id (hard coded value)
		Data length (bytes)
		ModelInstance
		Real data storage
		Integer data storage
		Real backup data storage (only for ME)
		Jacobian storage
		Error code
		String storage
*/
#define FMUStateID 983472598

fmi2Status fmi2GetFMUstate (
	fmi2Component	c,
	fmi2FMUstate*	FMUstate
)
{
	ModelInstance* comp = (ModelInstance *)c;
	char *cur;
	fmi2Real *rcur;
	M_INT i,j,*icur,wsto,ssto,jsto,totsto;

	if (invalidState(comp, "fmi2GetFMUstate", modelInitialized))
		return fmi2Error;

	if(comp->fmuType==fmi2ModelExchange)
		wsto = NUMBER_OF_REALS*sizeof(fmi2Real);
	else
		wsto = 0;

#ifdef FMI2_PROVIDES_DERIVATIVES
	jsto=( (1+NDIFF+NINP)*(NDIFF+NOUT) + NIUNK*(NIKNO+1) )*sizeof(fmi2Real);
#else
	jsto=0;
#endif

	ssto=0;
	for(i=0;i<NUMBER_OF_STRINGS;i++)
		if(comp->s[i])
			ssto+=strlen(comp->s[i])+1;
		else
			ssto++;

	totsto = 2*sizeof(M_INT) +
				sizeof(ModelInstance) +
				NUMBER_OF_REALS*sizeof(fmi2Real) +
				NUMBER_OF_INTEGERS*sizeof(M_INT) +
				wsto +
				jsto +
				sizeof(M_INT) +
				ssto;

	/* Verify that previously allocated FMU state is of sufficient size */
	if(*FMUstate) {
		icur=(M_INT *)(*FMUstate);
		if(icur[0]!=FMUStateID) {
			/* FMUstate pointer is not previously allocated in this routine
				so no way to verify the size */
			compLog(compEnv, comp->instanceName, fmi2Warning, "warning",
				"fmi2GetFMUstate: called with non-NULL state pointer of unknown size. Assuming sufficiently large.");
		}
		else if(icur[1]<totsto) {
			comp->functions.freeMemory(*FMUstate);
			*FMUstate=NULL;
		}
	}

	if(*FMUstate==NULL)
		FMUstate[0] = (fmi2FMUstate)comp->functions.allocateMemory(1,totsto);

	cur = (char *)(*FMUstate);

	icur = (M_INT *)cur;
	icur[0] = FMUStateID;
	icur[1] = totsto;
	cur += 2*sizeof(M_INT);

	memcpy(cur,comp,sizeof(ModelInstance));
	cur += sizeof(ModelInstance);

	rcur = (fmi2Real*)cur;
	for (i=0;i<NUMBER_OF_REALS;i++)	rcur[i] = comp->S.w[i];
	cur += NUMBER_OF_REALS*sizeof(fmi2Real);

	icur = (M_INT *)cur;
	for (i=0;i<NUMBER_OF_INTEGERS;i++) icur[i] = comp->S.iw[i];
	cur += NUMBER_OF_INTEGERS*sizeof(M_INT);

	if(comp->fmuType==fmi2ModelExchange) {
		rcur = (fmi2Real*)cur;
		for (i=0;i<NUMBER_OF_REALS;i++)	rcur[i] = comp->S.wset[i];
		cur += NUMBER_OF_REALS*sizeof(fmi2Real);
	}

#ifdef FMI2_PROVIDES_DERIVATIVES
	rcur = (fmi2Real*)cur;
	for (i=0;i<(1+NDIFF+NINP)*(NDIFF+NOUT);i++)	rcur[i] = comp->Jacobian[i];
	cur += (1+NDIFF+NINP)*(NDIFF+NOUT)*sizeof(fmi2Real);

	rcur = (fmi2Real*)cur;
	for (i=0;i<NIUNK*NIKNO;i++)	rcur[i] = comp->initJacobian[i];
	cur += NIUNK*NIKNO*sizeof(fmi2Real);

	rcur = (fmi2Real*)cur;
	for (i=0;i<NIUNK;i++)	rcur[i] = comp->initRes[i];
	cur += NIUNK*sizeof(fmi2Real);
#endif

	icur = (M_INT *)cur;
	icur[0] = errorOccured;
	cur += sizeof(M_INT);

	for(i=0;i<NUMBER_OF_STRINGS;i++) {
		if(comp->s[i]) {
			for(j=0;comp->s[i][j]!='\0';j++)
				*(cur++)=comp->s[i][j];
		}
		*(cur++)='\0';
	}

	return fmi2OK;
}
/* END: fmi2GetFMUstate */
/*****************************************************************************/

/*****************************************************************************/
/* BEGIN: fmi2SetFMUstate */
/*****************************************************************************/
fmi2Status fmi2SetFMUstate (fmi2Component	c,
							fmi2FMUstate	FMUstate) {
	ModelInstance* comp = (ModelInstance *)c;
	char *cur;
	fmi2String *scur;
	fmi2Real *rcur,*wcur,*jcur1,*jcur2,*jcur3;
	M_INT i,j,l,*icur;

	if (invalidState(comp, "fmi2SetFMUstate", modelInitialized))
		return fmi2Error;

	cur = (char *)FMUstate;
	icur = (M_INT *)cur;
	if(icur[0]!=FMUStateID) {
		compLog(compEnv, comp->instanceName, fmi2Error, "error",
			"fmi2SetFMUstate: called with invalid FMUstate");
		return(fmi2Error);
	}
	cur += 2*sizeof(M_INT);

	rcur = comp->S.w;
	icur = comp->S.iw;
	wcur = comp->S.wset;
	jcur1 = comp->Jacobian;
	jcur2 = comp->initJacobian;
	jcur3 = comp->initRes;
	scur = comp->s;
	memcpy(comp,cur,sizeof(ModelInstance));
	comp->S.w  = rcur;
	comp->S.iw = icur;
	comp->S.wset = wcur;
	comp->Jacobian = jcur1;
	comp->initJacobian = jcur2;
	comp->initRes = jcur3;
	comp->s = scur;
	cur += sizeof(ModelInstance);

	rcur = (fmi2Real *)cur;
	for(i=0;i<NUMBER_OF_REALS;i++) comp->S.w[i] = rcur[i];
	cur += NUMBER_OF_REALS*sizeof(fmi2Real);

	icur = (M_INT *)cur;
	for (i=0;i<NUMBER_OF_INTEGERS;i++) comp->S.iw[i] = icur[i];
	cur += NUMBER_OF_INTEGERS*sizeof(M_INT);

	if(comp->fmuType==fmi2ModelExchange) {
		rcur = (fmi2Real *)cur;
		for(i=0;i<NUMBER_OF_REALS;i++) comp->S.wset[i] = rcur[i];
		cur += NUMBER_OF_REALS*sizeof(fmi2Real);
	}
	else
		comp->S.wset = NULL;

#ifdef FMI2_PROVIDES_DERIVATIVES
	rcur = (fmi2Real*)cur;
	for (i=0;i<(1+NDIFF+NINP)*(NDIFF+NOUT);i++)	comp->Jacobian[i] = rcur[i];
	cur += (1+NDIFF+NINP)*(NDIFF+NOUT)*sizeof(fmi2Real);

	rcur = (fmi2Real*)cur;
	for (i=0;i<NIUNK*NIKNO;i++)	comp->initJacobian[i] = rcur[i];
	cur += NIUNK*NIKNO*sizeof(fmi2Real);

	rcur = (fmi2Real*)cur;
	for (i=0;i<NIUNK;i++)	comp->initRes[i] = rcur[i];
	cur += NIUNK*sizeof(fmi2Real);
#else
	comp->Jacobian = NULL;
	comp->initJacobian = NULL;
	comp->initRes = NULL;
#endif

	icur = (M_INT *)cur;
	errorOccured = icur[0];
	cur += sizeof(M_INT);

	for(i=0;i<NUMBER_OF_STRINGS;i++) {
		l=(comp->s[i]) ? strlen(comp->s[i]) : 0;
		j=strlen(cur);
		if(j>l) {
			if(comp->s[i]) comp->functions.freeMemory((char *)comp->s[i]);
			comp->s[i]=(fmi2String)comp->functions.allocateMemory(1,j+1);
		}
		strcpy((char *)comp->s[i],cur);
		cur += j+1;
	}

	return fmi2OK;
}
/* END: fmi2SetFMUstate */
/*****************************************************************************/

/*****************************************************************************/
/* BEGIN: fmi2FreeFMUstate */
/*****************************************************************************/
fmi2Status fmi2FreeFMUstate(fmi2Component c,
							fmi2FMUstate* FMUstate) {
	ModelInstance* comp = (ModelInstance *)c;
	M_INT *icur;

	if (invalidState(comp, "fmi2FreeFMUstate",
		modelInstantiated|modelInitialized|modelTerminated|modelError))
		return fmi2Error;

	if( *FMUstate ) {
		icur = (M_INT *)(*FMUstate);
		if(icur[0]!=FMUStateID)
			compLog(compEnv, comp->instanceName, fmi2Warning, "warning",
				"fmi2FreeFMUstate: called with invalid FMUstate");
		comp->functions.freeMemory(*FMUstate);
	}

	*FMUstate = NULL;

	return fmi2OK;
}
/* END: fmi2FreeFMUstate */
/*****************************************************************************/

/*****************************************************************************/
/* BEGIN: fmi2SerializedFMUstateSize */
/*****************************************************************************/
fmi2Status fmi2SerializedFMUstateSize(	fmi2Component	c,
										fmi2FMUstate	FMUstate,
										size_t			*size) {
	ModelInstance* comp = (ModelInstance *)c;
	M_INT *icur;

	if (invalidState(comp, "fmi2SerializedFMUstateSize", modelInitialized))
		return fmi2Error;

	icur = (M_INT *)FMUstate;
	if(icur[0]!=FMUStateID) {
		compLog(compEnv, comp->instanceName, fmi2Error, "error",
			"fmi2SerializedFMUstateSize: called with invalid FMUstate");
		return(fmi2Error);
	}
	*size = (size_t)icur[1];

	return fmi2OK;
}
/* END: fmi2SerializedFMUstateSize */
/*****************************************************************************/

/*****************************************************************************/
/* BEGIN: fmi2SerializeFMUstate */
/*****************************************************************************/
fmi2Status fmi2SerializeFMUstate(fmi2Component		c,
								fmi2FMUstate		FMUstate,
								fmi2Byte 			serializedState[],
								size_t				size) {
	ModelInstance* comp = (ModelInstance *)c;
	M_INT *icur;

	if (invalidState(comp, "fmi2SerializeFMUstate", modelInitialized))
		return fmi2Error;

	icur = (M_INT *)FMUstate;
	if(icur[0]!=FMUStateID) {
		compLog(compEnv, comp->instanceName, fmi2Error, "error",
			"fmi2SerializedFMUstate: called with invalid FMUstate");
		return fmi2Error;
	}
	if(icur[1]>(M_INT)size) {
		compLog(compEnv, comp->instanceName, fmi2Error, "error",
			"fmi2SerializedFMUstate: called with size not sufficient to contain FMUstate");
		return fmi2Error;
	}
	memcpy(serializedState, FMUstate, size);

	return fmi2OK;
}
/* END: fmi2SerializeFMUstate */
/*****************************************************************************/

/*****************************************************************************/
/* BEGIN: fmi2DeSerializeFMUstate */
/*****************************************************************************/
fmi2Status fmi2DeSerializeFMUstate(	fmi2Component	c,
									const fmi2Byte	serializedState[],
									size_t			size,
									fmi2FMUstate	*FMUstate) {
	ModelInstance* comp = (ModelInstance *)c;
	M_INT *icur;

	if (invalidState(comp, "fmi2DeSerializeFMUstate", modelInitialized))
		return fmi2Error;

	icur = (M_INT *)serializedState;
	if(icur[0]!=FMUStateID) {
		compLog(compEnv, comp->instanceName, fmi2Error, "error",
			"fmi2DeSerializedFMUstate: called with serializedState not containing valid FMUstate");
		return fmi2Error;
	}
	if(icur[1]>(M_INT)size) {
		compLog(compEnv, comp->instanceName, fmi2Error, "error",
			"fmi2SerializedFMUstate: called with size not sufficient to contain serializedState");
		return fmi2Error;
	}
	FMUstate[0] = (fmi2FMUstate)comp->functions.allocateMemory(1,size);
	memcpy(*FMUstate, serializedState, size);

	return fmi2OK;
}
/* END: fmi2DeSerializeFMUstate */
/*****************************************************************************/

/*****************************************************************************/
/* BEGIN: fmi2GetDirectionalDerivative */
/*****************************************************************************/
fmi2Status fmi2GetDirectionalDerivative(	fmi2Component			c,
										const fmi2ValueReference	vUnknown_ref[],
										size_t						nUnknown,
										const fmi2ValueReference	vKnown_ref[],
										size_t						nKnown,
										const fmi2Real				dvKnown[],
										fmi2Real					dvUnknown[]) {
#ifdef FMI2_PROVIDES_DERIVATIVES
	int i, j, k, row, col, offset;
	fmi2Status sts;
	fmi2ValueReference vrs, vrd;
	ModelInstance* comp = (ModelInstance *)c;

	if (invalidState(comp, "fmi2GetDirectionalDerivatives", modelInstantiated|modelInitialized))
		return fmi2Error;
	if (nKnown>0 && nullPointer(comp, "fmi2GetDirectionalDerivative", "vKnown_ref[]", vKnown_ref))
		return fmi2Error;
	if (nUnknown>0 && nullPointer(comp, "fmi2GetDirectionalDerivative", "vUnknown_ref[]", vUnknown_ref))
		return fmi2Error;
	if (nKnown>0 && nullPointer(comp, "fmi2GetDirectionalDerivative", "dvKnown[]", dvKnown))
		return fmi2Error;

	sts = syncModel(comp,"fmi2GetDirectionalDerivative");
	if ( sts!=fmi2OK ) return sts;

	/* Initialize unknown vector */
	for (i=0; i<nUnknown; i++) dvUnknown[i] = 0.;

	/* Get Jacobian information, dimensions, data, etc? */
	if(!comp->jsynced) {
		if(comp->initializeMode)
			initjac(comp->S.w[0],&(comp->S.w[1]),&(comp->S.w[NEQ+NPAR+1]),comp->initRes,comp->initJacobian);
		else
			intjac(comp->S.w[0],&(comp->S.w[1]),&(comp->S.w[NEQ+NPAR+1]),comp->Jacobian);
		comp->jsynced = fmi2True;
	}

	/* Order of value references :
	t, #states, #index-1(inps), #discrete, #params, #derivs, #events */

	/* Start the computation loop */
	if (comp->initializeMode) {
		offset = NIKNO;
		for (i=0; i<nKnown; i++) {
			/* Check the seed */
			if (dvKnown[i]!=0) {
				vrs = vKnown_ref[i];
				/* assert(vr>=0 && vr<NUMBER_OF_REALS); */
				col = -1;
				for (k=0; k<NIKNO; k++)
					if (vrs==vrIknowns[k]) {
						col = k;
						break;
					}
				/* Compute column i */
				for (j=0; j<nUnknown; j++) {
					vrd = vUnknown_ref[j];
					/* assert(vrd>=0 && vrd<NUMBER_OF_REALS); */
					if ( vrd==vrs ) {
						dvUnknown[j] += 1.0;
					}
					else if(col!=-1) {
						for (k=0; k<NIUNK; k++)
							if (vrd==vrIunknowns[k]) {
								dvUnknown[j] += dvKnown[i]*comp->initJacobian[k*offset+col];
								break;
							}
					}
				}
			}
		}
	}
	else {
		offset = 1+NDIFF+NINP;
		for (i=0; i<nKnown; i++) {
			/* Check the seed */
			if (dvKnown[i]!=0) {
				vrs = vKnown_ref[i];
				/* assert(vr>=0 && vr<NUMBER_OF_REALS); */
				/* Check that vKnown_ref[i] is a state or input */
				if ( vrs==0 || (vrs>=vrStates[0] && vrs<vrStates[0]+NDIFF) )
					col = vrs;
				else if(vrs>=1+NDIFF+NIX1-NINP && vrs<1+NDIFF+NIX1)
					col = vrs-(NIX1-NINP);
				else
					return fmi2Error;
				/* Compute column i */
				for (j=0; j<nUnknown; j++) {
					vrd = vUnknown_ref[j];
					/* assert(vrd>=0 && vrd<NUMBER_OF_REALS); */
					/* Check if vrd is a derivative or an output,
					it could also be an output that's a state */
					if ( vrd>=vrDers[0] && vrd<vrDers[0]+NDIFF ) {
						row = vrd-vrDers[0];
						dvUnknown[j] += dvKnown[i]*comp->Jacobian[row*offset+col];
					}
					else if( vrd>=vrStates[0] && vrd<vrStates[0]+NDIFF ) {
						if ( vrd==vrs ) dvUnknown[j] += 1.0;
					}
					else {
						for (k=0; k<NOUT; k++)
							if (vrd==vrOuts[k]) {
								/* refval-t-states+derivs: vrd-1-NDIFF+NDIFF */
								row = vrd-1;
								dvUnknown[j] += dvKnown[i]*comp->Jacobian[row*offset+col];
								break;
							}
						if (k==NOUT) return fmi2Error;
					}
				}
			}
		}
	}
	return fmi2OK;
#else
	/* Compiler warning fix */
	int i=nUnknown+nKnown;
	void *tmp;
	tmp=(void *)vUnknown_ref;
	tmp=(void *)vKnown_ref;
	tmp=(void *)dvKnown;
	tmp=(void *)dvUnknown;
	if(i>0) tmp=(void *)c;
	i=((int *)tmp)[0];
	/* End compiler warning fix */
	return fmi2Error;
#endif
}
/* END: fmi2GetDirectionalDerivative */
/*****************************************************************************/

#if NCON>0 && defined(WMI_PROJECTION)
/*****************************************************************************/
/* BEGIN: fmi2Projection */
/*****************************************************************************/
fmi2Status fmi2Projection(	fmi2Component	c,
								fmi2Real	P[],
								fmi2Real	projectionTolerance,
								size_t	iterationLimit,
								fmi2Boolean	apply) {
	int i;
	fmi2Status sts;
	fmi2Real S2[NDIFF];

	ModelInstance* comp = (ModelInstance *)c;

	if (invalidState(comp, "fmi2Projection", modelInstantiated|modelInitialized))
		return fmi2Error;

	sts = syncModel(comp,"fmi2Projection");
	if ( sts!=fmi2OK ) return sts;

	for(i=0;i<NDIFF;i++) S2[i] = comp->S.w[i+1];
	i=Projection(comp->S.w[0], &comp->S.w[1], projectionTolerance, iterationLimit, NULL, comp->S.psto);
	if( i!=0 ){
		/* Restore state */
		for(i=0;i<NDIFF;i++) comp->S.w[i+1]=S2[i];
		return fmi2Discard;
	}
	for(i=0;i<NDIFF;i++) P[i] = comp->S.w[i+1]-S2[i];

	if( !apply ){
		for(i=0;i<NDIFF;i++) comp->S.w[i+1]=S2[i];
	}

	return fmi2OK;
}
/* END: fmi2Projection */
/*****************************************************************************/

/*****************************************************************************/
/* BEGIN: fmi2ProjectionStep: No longer supported */
/*****************************************************************************/
fmi2Status fmi2ProjectionStep(  fmi2Component	c,
								fmi2Real	S[]) {
	UNUSED(c);
	UNUSED(S);
	return fmi2Error;
}
/* END: fmi2ProjectionStep */
/*****************************************************************************/

/*****************************************************************************/
/* BEGIN: fmi2Constraint */
/*****************************************************************************/
fmi2Status fmi2Constraint(	fmi2Component	c,
								fmi2Real	C[]) {
	int cb, cr, nblk;
	fmi2Real blkdata[2];
	fmi2Status sts;

	ModelInstance* comp = (ModelInstance *)c;

	if (invalidState(comp, "fmi2Constraint", modelInstantiated|modelInitialized))
		return fmi2Error;

	sts = syncModel(comp,"fmi2Constraint");
	if ( sts!=fmi2OK ) return sts;

	/* Iterate over Residual blocks */
	Rblkp(comp->S.w[0], &comp->S.w[1], blkdata, 0, 0);
	nblk = (int)(blkdata[0]);
	cr = 0;
	for(cb=1;cb<=nblk;cb++) {
		Rblkp(comp->S.w[0], &comp->S.w[1], &C[cr], cb, 3);
		Rblkp(comp->S.w[0], &comp->S.w[1], blkdata, cb, 1);
		cr += (int)(blkdata[0]);
	}

	return fmi2OK;
}
/* END: fmi2Constraint */
/*****************************************************************************/

/*****************************************************************************/
/* BEGIN: fmi2ConstraintJacobian: No longer supported */
/*****************************************************************************/
fmi2Status fmi2ConstraintJacobian(	fmi2Component	c,
										fmi2Real	J[]) {

	/* If this function is required at some point, the code will need to be
	modified to fill in the ncon x ndiff Matrix using a sequence of calls to
	the block-based Jacobian. It is known that this will provide 0 entries
	for block dependencies on vars from a prior block, but this will only
	slow convergence of a newton approach, and be irrelevant when sufficiently
	close to the solution manifold */
	UNUSED(c);
	UNUSED(J);
	return fmi2Error;
}
/* END: fmi2ConstraintJacobian */
/*****************************************************************************/
#endif

#ifdef FMI2_COSIMULATION
/*****************************************************************************
 * FMI functions: only for FMI Co-Simulation 2.0
 *****************************************************************************/
/*****************************************************************************/
/* BEGIN: fmi2SetRealInputDerivatives */
fmi2Status fmi2SetRealInputDerivatives(	fmi2Component			c,
										const fmi2ValueReference vr[],
										size_t					nvr,
										const fmi2Integer		order[],
										const fmi2Real			value[]) {
	ModelInstance* comp = (ModelInstance *)c;

	if (invalidState(comp, "fmi2SetRealInputDerivatives", modelInitialized))
		return fmi2Error;
	if (comp->loggingOn)
		compLog(compEnv, comp->instanceName, fmi2OK, "log",
				"fmi2SetRealInputDerivatives: nvr= %d", nvr);

	UNUSED(vr);
	UNUSED(order);
	UNUSED(value);
	compLog(NULL, comp->instanceName, fmi2Error, "warning",
			"fmi2SetRealInputDerivatives: ignoring function call."
			" This model cannot interpolate inputs: canInterpolateInputs = \"fmi2False\"");

	return fmi2Warning;
}
/* END: fmi2SetRealInputDerivatives */
/*****************************************************************************/

/*****************************************************************************/
/* BEGIN: fmi2GetRealOutputDerivatives */
fmi2Status fmi2GetRealOutputDerivatives(fmi2Component			c,
										const fmi2ValueReference vr[],
										size_t					nvr,
										const fmi2Integer		order[],
										fmi2Real				value[]) {
	int i;
	ModelInstance* comp = (ModelInstance *)c;

	if (invalidState(comp, "fmi2GetRealOutputDerivatives", modelInitialized))
		return fmi2Error;
	if (comp->loggingOn)
		compLog(compEnv, comp->instanceName, fmi2OK, "log",
				"fmi2GetRealOutputDerivatives: nvr= %d",	nvr);

	UNUSED(vr);
	UNUSED(order);
	compLog(NULL, comp->instanceName, fmi2Error, "warning",
			"fmi2GetRealOutputDerivatives: ignoring function call."
			" This model cannot compute derivatives of outputs: MaxOutputDerivativeOrder=\"0\"");

	for (i=0; i<(int)nvr; i++) value[i] = 0;

	return fmi2Warning;
}
/* END: fmi2GetRealOutputDerivatives */
/*****************************************************************************/

#define MAX_STEP  1.00000000000000000e-03

/*****************************************************************************/
/* BEGIN: fmi2DoStep */
fmi2Status fmi2DoStep(  fmi2Component	c,
						fmi2Real		currentCommunicationPoint,
						fmi2Real		communicationStepSize,
						fmi2Boolean		newStep) {

	ModelInstance* comp	= (ModelInstance *)c;
	int		i;
	double	h;
#if NEVT>0
	M_INT *modes;
	double	prevEventIndicators[max(NEVT, 1)];
#endif

	if (invalidState(comp, "fmi2DoStep", modelInitialized)) return fmi2Error;

	if (comp->loggingOn)
		compLog(compEnv, comp->instanceName, fmi2OK, "log", "fmi2DoStep: "
				"currentCommunicationPoint = %g, "
				"communicationStepSize = %g, "
				"newStep = fmi2%s",
				currentCommunicationPoint, communicationStepSize, newStep ? "True" : "False");

	if (comp->stopTimeDefined && currentCommunicationPoint+communicationStepSize > comp->stopTime) {
		comp->state = modelError;
		return fmi2Error;
	}

#if NPAR>0
	if(pchange) {
		SolverInitialize(&(comp->S));
		pchange=0;
		if (errorOccured>0) {
			setVidError(comp,NULL);
			if (comp->fptr) {
				writeErrorToFile(comp->fptr,NULL);
				comp->fptr = NULL;
			}
			comp->state = modelTerminated;
			logMessage(comp, "fmi2DoStep", "error", fmi2Error);
			return fmi2Error;
		}
		else if(errorOccured<0) {
			logMessage(comp, "fmi2DoStep", "warning", fmi2Warning);
			errorOccured=0;
		}
	}
#endif

#if NEVT>0
	/* Run to get initial event indicators */
	eev(comp->S.w[0],&(comp->S.w[1]),&(comp->S.w[1]),prevEventIndicators);
	modes=comp->S.iw;
	ComputeEventIndicators(prevEventIndicators,&(comp->S.w[1]),modes,
		&modes[3*NEVT],&modes[2*NEVT],&modes[4*NEVT]);
#endif

	comp->S.w[0] = currentCommunicationPoint;
	if( currentCommunicationPoint < (comp->lastSuccessfulTime-10.*ULP1) )
		comp->lastStepSize = -1.;
	h = ( comp->lastStepSize<0. ) ? communicationStepSize/100. : comp->lastStepSize;
	warningOccured=0;
	/* Call the variable step integrator */
	i = Integrate(comp->S.w,comp->S.iw,currentCommunicationPoint+communicationStepSize,
				ERRTOL,&h);
	if(warningOccured) {
		logWarning(comp, "Integrate", "warning", fmi2Warning);
		warningOccured=0;
	}
	if(i!=1) {
		if (errorOccured>0) {
			comp->state = modelTerminated;
			logMessage(comp, "fmi2DoStep", "error", fmi2Error);
			return fmi2Error;
		}
	}
	comp->lastStepSize = (fmi2Real)h;
	comp->synced = fmi2True;
	comp->jsynced = fmi2False;
	SolverOutputs(&(comp->S));

	comp->lastSuccessfulTime = currentCommunicationPoint + communicationStepSize;
	comp->vidsts = 2;
 	if (comp->fptr)
		fwrite(comp->S.w,sizeof(fmi2Real),NEQ+1,comp->fptr);

	return fmi2OK;
}
/* END: fmi2DoStep */
/*****************************************************************************/

/*****************************************************************************/
/* BEGIN: fmi2CancelStep */
fmi2Status fmi2CancelStep(fmi2Component c) {
	ModelInstance* comp = (ModelInstance *)c;

	if (invalidState(comp, "fmi2CancelStep", modelInitialized)) return fmi2Error;
	if (comp->loggingOn)
		compLog(compEnv, comp->instanceName, fmi2OK, "log", "fmi2CancelStep");

	compLog(NULL, comp->instanceName, fmi2Error, "error",
			"fmi2CancelStep: Can be called when fmi2DoStep returned fmi2Pending."
			" This is not the case.");
	comp->state = modelError;
	return fmi2Error;
}
/* END: fmi2CancelStep */
/*****************************************************************************/

/*****************************************************************************/
/* BEGIN: fmi2GetStatus */
fmi2Status fmi2GetStatus(	fmi2Component		c,
							const fmi2StatusKind s,
							fmi2Status*			value) {
	ModelInstance* comp = (ModelInstance *)c;

	if (invalidState(comp, "fmi2GetStatus", modelInstantiated|modelInitialized))
		return fmi2Error;

	UNUSED(value);
	if (s==fmi2DoStepStatus) {
		if (comp->loggingOn) {
			compLog(compEnv, comp->instanceName, fmi2OK, "log",
				"[fmi2GetStatus]: fmi2StatusKind = fmi2DoStepStatus");
			compLog(NULL, comp->instanceName, fmi2Error, "error",
				"[fmi2GetStatus]: Can be called with fmi2DoStepStatus when fmi2DoStep returned fmi2Pending."
				" This is not the case.");
		}
		return fmi2Discard;
	}
	else
		return fmi2Discard;
}
/* END: fmi2GetStatus */
/*****************************************************************************/

/*****************************************************************************/
/* BEGIN: fmi2GetRealStatus */
fmi2Status fmi2GetRealStatus(	fmi2Component		c,
								const fmi2StatusKind s,
								fmi2Real*			value) {
	ModelInstance* comp = (ModelInstance *)c;

	if (invalidState(comp, "fmi2GetRealStatus", modelInstantiated|modelInitialized))
		return fmi2Discard;

	if (s==fmi2LastSuccessfulTime) {
		if (comp->loggingOn) {
			compLog(compEnv, comp->instanceName, fmi2OK, "log",
				"[fmi2GetRealStatus]: fmi2StatusKind = fmi2LastSuccessfulTime");
		}
		if (comp->state==modelTerminated) {
			*value = comp->lastSuccessfulTime;
			return fmi2OK;
		}
		else {
			compLog(NULL, comp->instanceName, fmi2Error, "error",
				"[fmi2GetRealStatus]: Can be called with fmi2LastSuccessfulTime when fmi2DoStep returned fmi2Discard."
				" This is not the case.");
			return fmi2Discard;
		}
	}
	else
		return fmi2Discard;
}
/* END: fmi2GetRealStatus */
/*****************************************************************************/

/*****************************************************************************/
/* BEGIN: fmi2GetIntegerStatus */
fmi2Status fmi2GetIntegerStatus(fmi2Component		c,
								const fmi2StatusKind s,
								fmi2Integer*		value) {
	UNUSED(c);
	UNUSED(s);
	UNUSED(value);
	return fmi2Discard;
}
/* END: fmi2GetIntegerStatus */
/*****************************************************************************/

/*****************************************************************************/
/* BEGIN: fmi2GetBooleanStatus */
fmi2Status fmi2GetBooleanStatus(fmi2Component		c,
								const fmi2StatusKind s,
								fmi2Boolean*		value) {
	ModelInstance* comp = (ModelInstance *)c;

	if (invalidState(comp, "fmi2GetBooleanStatus", modelInstantiated|modelInitialized))
		return fmi2Discard;

	if (s==fmi2Terminated) {
		if (comp->loggingOn) {
			compLog(compEnv, comp->instanceName, fmi2OK, "log",
				"[fmi2GetBooleanStatus]: fmi2StatusKind = fmi2Terminated");
		}
		if (comp->state==modelTerminated)
			*value = fmi2True;
		else
			*value = fmi2False;
		return fmi2OK;
	}
	else
		return fmi2Discard;
}
/* END: fmi2GetBooleanStatus */
/*****************************************************************************/

/*****************************************************************************/
/* BEGIN: fmi2GetStringStatus */
fmi2Status fmi2GetStringStatus(	fmi2Component		c,
								const fmi2StatusKind s,
								fmi2String*			value) {
	ModelInstance* comp = (ModelInstance *)c;

	if (invalidState(comp, "fmi2GetStringStatus", modelInstantiated|modelInitialized))
		return fmi2Discard;

	UNUSED(value);
	if (s==fmi2PendingStatus) {
		if (comp->loggingOn) {
			compLog(compEnv, comp->instanceName, fmi2OK, "log",
				"[fmi2GetStringStatus]: fmi2StatusKind = fmi2PendingStatus");
			compLog(NULL, comp->instanceName, fmi2Error, "error",
					"[fmi2GetStringStatus]: Can be called with fmi2PendingStatus when fmi2DoStep returned fmi2Pending."
					" This is not the case.");
		}
		return fmi2Discard;
	}
	else
		return fmi2Discard;
}
/* END: fmi2GetStringStatus */
/*****************************************************************************/

#else
/*****************************************************************************
 * FMI functions: only for Model Exchange 2.0
 *****************************************************************************/

/*****************************************************************************/
/* BEGIN: fmi2EnterEventMode */
fmi2Status fmi2EnterEventMode(fmi2Component c) {
	ModelInstance* comp = (ModelInstance *)c;

	if (comp) {
		comp->lastEventTime = comp->S.w[0]-1.0;
		return fmi2OK;
	}
	else
		return fmi2Error;
}
/* END: fmi2EnterEventMode */
/*****************************************************************************/

/*****************************************************************************/
/* BEGIN: fmi2NewDiscreteStates */
fmi2Status fmi2NewDiscreteStates(fmi2Component	c,
								fmi2EventInfo*	eventInfo) {
	ModelInstance* comp = (ModelInstance *)c;
	int i;
#if NEVT+NCON>0
	fmi2Real save[NEQ],val;
#endif
	if (invalidState(comp, "fmi2NewDiscreteStates", modelInitialized))
		return fmi2Error;
	if (nullPointer (comp, "fmi2NewDiscreteStates", "eventInfo", eventInfo))
		return fmi2Error;

	eventInfo->newDiscreteStatesNeeded				= fmi2False;
	eventInfo->nominalsOfContinuousStatesChanged	= fmi2False;
	eventInfo->valuesOfContinuousStatesChanged		= fmi2False;
	eventInfo->terminateSimulation					= fmi2False;
	eventInfo->nextEventTimeDefined					= fmi2False;
	eventInfo->nextEventTime						= -0.0;

#if NEVT+NCON>0
	for(i=0;i<NEQ;i++) save[i]=comp->S.w[i+1];
#endif
	i=SolverProject(&(comp->S));
	if (i<0 || errorOccured==1) {
		setVidError(comp,NULL);
		if (comp->fptr) {
			writeErrorToFile(comp->fptr,NULL);
			comp->fptr = NULL;
		}
		eventInfo->terminateSimulation = fmi2True;
		comp->state = modelTerminated;
		logMessage(comp, "fmi2NewDiscreteStates", "error", fmi2Error);
		return fmi2Error;
	}
	else if (i>0 || errorOccured==2) {
		compLog(compEnv, comp->instanceName, fmi2OK, "log",
				"fmi2NewDiscreteStates: model requested termination at t = %g",
				comp->S.w[0]);
		setVidError(comp,NULL);
		if (comp->fptr) {
			writeErrorToFile(comp->fptr,NULL);
			comp->fptr = NULL;
		}
		eventInfo->terminateSimulation = fmi2True;
		comp->state = modelTerminated;
		logMessage(comp, "fmi2NewDiscreteStates", "warning", fmi2Discard);
		return fmi2OK;
	}
	else if(errorOccured<0) {
		logMessage(comp, "fmi2NewDiscreteStates", "warning", fmi2Warning);
		errorOccured=0;
	}
#if NEVT>0
	if (comp->S.w[0]!=comp->lastEventTime) {
		i=RunEvents(comp->S.w, comp->S.iw, 0, -1, EVTITER, comp->S.psto);
		if (i<0 || errorOccured==1) {
			setVidError(comp,NULL);
			if (comp->fptr) {
				writeErrorToFile(comp->fptr,NULL);
				comp->fptr = NULL;
			}
			eventInfo->terminateSimulation = fmi2True;
			comp->state = modelTerminated;
			logMessage(comp, "fmi2NewDiscreteStates", "error", fmi2Error);
			return fmi2Error;
		}
		else if (i>0 || errorOccured==2) {
			compLog(compEnv, comp->instanceName, fmi2OK, "log",
					"fmi2NewDiscreteStates: model requested termination at t = %g",
					comp->S.w[0]);
			setVidError(comp,NULL);
			if (comp->fptr) {
				writeErrorToFile(comp->fptr,NULL);
				comp->fptr = NULL;
			}
			eventInfo->terminateSimulation = fmi2True;
			comp->state = modelTerminated;
			logMessage(comp, "fmi2NewDiscreteStates", "warning", fmi2Discard);
			return fmi2OK;
		}
		else if(errorOccured<0) {
			logMessage(comp, "fmi2NewDiscreteStates", "warning", fmi2Warning);
			errorOccured=0;
		}
		comp->lastEventTime = comp->S.w[0];
	}
	i=RunEvents(comp->S.w, comp->S.iw, 1, -1, EVTITER, comp->S.psto);
	if (i<0 || errorOccured==1) {
		setVidError(comp,NULL);
		if (comp->fptr) {
			writeErrorToFile(comp->fptr,NULL);
			comp->fptr = NULL;
		}
		eventInfo->terminateSimulation = fmi2True;
		comp->state = modelTerminated;
		logMessage(comp, "fmi2NewDiscreteStates", "error", fmi2Error);
		return fmi2Error;
	}
	else if (i>0 || errorOccured==2) {
		compLog(compEnv, comp->instanceName, fmi2OK, "log",
				"fmi2NewDiscreteStates: model requested termination at t = %g",
				comp->S.w[0]);
		setVidError(comp,NULL);
		if (comp->fptr) {
			writeErrorToFile(comp->fptr,NULL);
			comp->fptr = NULL;
		}
		eventInfo->terminateSimulation = fmi2True;
		comp->state = modelTerminated;
		logMessage(comp, "fmi2NewDiscreteStates", "warning", fmi2Discard);
		return fmi2OK;
	}
	else if(errorOccured<0) {
		logMessage(comp, "fmi2NewDiscreteStates", "warning", fmi2Warning);
		errorOccured=0;
	}
#endif
#if NEVT+NCON>0
	for(i=0;i<NEQ;i++) {
		val=1e-15;
		if(fabs(save[i])>val) val=fabs(save[i]);
		if(fabs(comp->S.w[i+1])>val) val=fabs(comp->S.w[i+1]);
		if( fabs(comp->S.w[i+1]-save[i])>1e-12*val )
			eventInfo->valuesOfContinuousStatesChanged = fmi2True;
	}
	if(eventInfo->valuesOfContinuousStatesChanged==fmi2True)
		SolverOutputs(&(comp->S));
#endif
	return fmi2OK;
}
/* END: fmi2NewDiscreteStates */
/*****************************************************************************/

/*****************************************************************************/
/* BEGIN: fmi2EnterContinuousTimeMode */
fmi2Status fmi2EnterContinuousTimeMode(fmi2Component c) {
	if (c)	return fmi2OK;
	else	return fmi2Error;
}
/* END: fmi2EnterContinuousTimeMode */
/*****************************************************************************/

/*****************************************************************************/
/* BEGIN: fmi2CompletedIntegratorStep */
fmi2Status fmi2CompletedIntegratorStep(	fmi2Component	c,
										fmi2Boolean		noSetFMUStatePriorToCurrentPoint,
										fmi2Boolean*	enterEventMode,
										fmi2Boolean*	terminateSimulation) {
	ModelInstance* comp = (ModelInstance *)c;
	int i;
#if NCON>0 && defined(CONDSTEPEVENT)
	fmi2Real save[NEQ],val,drift;
#endif

	UNUSED(noSetFMUStatePriorToCurrentPoint);
	if (invalidState(comp, "fmi2CompletedIntegratorStep", modelInitialized))
		return fmi2Error;
	if (nullPointer (comp, "fmi2CompletedIntegratorStep", "enterEventMode", enterEventMode))
		return fmi2Error;
	if (nullPointer (comp, "fmi2CompletedIntegratorStep", "terminateSimulation", terminateSimulation))
		return fmi2Error;
	if (comp->loggingOn)
		compLog(compEnv, comp->instanceName, fmi2OK, "log",
				"fmi2CompletedIntegratorStep");

	*terminateSimulation = fmi2False;

	if (comp->synced)
		SolverUpdate(&(comp->S),1,1);
	else {
		SolverUpdate(&(comp->S),0,1);
		if (errorOccured>0) {
			setVidError(comp,NULL);
			if (comp->fptr) {
				writeErrorToFile(comp->fptr,NULL);
				comp->fptr = NULL;
			}
			errorOccured = 0;
			comp->state = modelTerminated;
			logMessage(comp, "fmi2CompletedIntegratorStep", "error", fmi2Discard);
			return fmi2Discard;
		}
		else if(errorOccured<0) {
			logMessage(comp, "fmi2CompletedIntegratorStep", "warning", fmi2Warning);
			errorOccured=0;
		}
		comp->synced = fmi2True;
		comp->jsynced = fmi2False;
	}
	if(comp->fmuType==fmi2ModelExchange && comp->S.wset)
		for(i=NDIFF+1;i<=NDIFF+NIX1-NINP;i++)
			comp->S.wset[i]=comp->S.w[i];
	SolverOutputs(&(comp->S));
	if( comp->S.w[0]>=(comp->vidlasttime+comp->minSampleStep)*(1-1e-15) ) {
		comp->vidsts=2;
		comp->vidlasttime=comp->S.w[0];
	}
 	if (comp->fptr)
		if ( comp->S.w[0]>=(comp->lastsampletime+comp->minSampleStep)*(1-1e-15) ) {
			fwrite(comp->S.w,sizeof(fmi2Real),NEQ+1,comp->fptr);
			comp->lastsampletime=comp->S.w[0];
			if ( comp->numpts++ == WARNNUMDATPTS )
				compLog(compEnv, comp->instanceName, fmi2Warning, "warning",
						"[fmi2CompletedIntegratorStep]: At time t=%.16g, %d data points were written into file %s; consider increasing the minimum sample step, %.16g, to limit file size.",
						comp->S.w[0], WARNNUMDATPTS, comp->fstr, comp->minSampleStep);
		}

#if !defined(WMI_PROJECTION) && NCON>0
#   if defined(CONDSTEPEVENT)
	for(i=0;i<NEQ;i++) save[i]=comp->S.w[i+1];
	i=SolverProject(&(comp->S));
	if (i<0 || errorOccured>=1) {
		errorOccured=0;
		*enterEventMode = fmi2True;
	}
	else if (i>0) {
		setVidError(comp,NULL);
		if (comp->fptr) {
			writeErrorToFile(comp->fptr,NULL);
			comp->fptr = NULL;
		}
		comp->state = modelTerminated;
		*terminateSimulation = fmi2True;
		logMessage(comp, "fmi2CompletedIntegratorStep", "error", fmi2Discard);
		return fmi2OK;
	}
	else {
		drift=0.0;
		for(i=0;i<NEQ;i++) {
			val=1e-15;
			if(fabs(save[i])>val) val=fabs(save[i]);
			if(fabs(comp->S.w[i+1])>val) val=fabs(comp->S.w[i+1]);
			val=fabs(comp->S.w[i+1]-save[i])/val;
			if(val>drift) drift=val;
		}
		val=(CONTOL<1e-8) ? 1e-10 : 0.01*CONTOL;
		if(drift>val)
			*enterEventMode = fmi2True;
		else
			*enterEventMode = fmi2False;
	}
	for(i=0;i<NEQ;i++) comp->S.w[i+1]=save[i];
#   else
	*enterEventMode = fmi2True;
#   endif
#else
	*enterEventMode = fmi2False;
#endif

	return fmi2OK;
}
/* END: fmi2CompletedIntegratorStep */
/*****************************************************************************/

/*****************************************************************************/
/* BEGIN: fmi2SetTime */
fmi2Status fmi2SetTime(	fmi2Component	c,
						fmi2Real		time) {
	ModelInstance* comp = (ModelInstance *)c;
	if (invalidState(comp, "fmi2SetTime", modelInstantiated|modelInitialized))
		return fmi2Error;
	if (comp->loggingOn)
		compLog(compEnv, comp->instanceName, fmi2OK, "log",
				"fmi2SetTime: time = %.16g", time);
	if (comp->S.w[0] != time) {
		comp->S.w[0] = time;
		comp->synced = fmi2False;
		comp->jsynced = fmi2False;
	}
	return fmi2OK;
}
/* END: fmi2SetTime */
/*****************************************************************************/

/*****************************************************************************/
/* BEGIN: fmi2SetContinuousStates */
fmi2Status fmi2SetContinuousStates(	fmi2Component	c,
									const fmi2Real	x[],
									size_t			nx){
	ModelInstance* comp = (ModelInstance *)c;
#if NDIFF>0
	double scalev;
	int i;
	fmi2ValueReference vr;
#endif

	if (invalidState (comp, "fmi2SetContinuousStates", modelInitialized))
		return fmi2Error;
	if (invalidNumber(comp, "fmi2SetContinuousStates", "nx", nx, NDIFF))
		return fmi2Error;
#if NDIFF>0
	if (nullPointer  (comp, "fmi2SetContinuousStates", "x[]", x))
		return fmi2Error;

	for (i=0; i<(int)nx; i++) {
		vr = vrStates[i];
		if (comp->loggingOn)
			compLog(compEnv, comp->instanceName, fmi2OK, "log",
					"fmi2SetContinuousStates: #r%d# = %.16g", vr, x[i]);
		/*assert(vr>=0 && vr<NUMBER_OF_REALS);*/
		if( nomfac )
			scalev = nomfac[i]*x[i];
		else
			scalev = x[i];
		if (comp->S.w[vr] != scalev) {
			comp->S.w[vr] = scalev;
			comp->synced = fmi2False;
			comp->jsynced = fmi2False;
		}
	}
#endif
	return fmi2OK;
}
/* END: fmi2SetContinuousStates */
/*****************************************************************************/

/*****************************************************************************/
/* BEGIN: fmi2GetDerivatives */
fmi2Status fmi2GetDerivatives(	fmi2Component	c,
								fmi2Real		derivatives[],
								size_t			nx) {
#if NDIFF>0
	int i;
#endif
	ModelInstance* comp = (ModelInstance *)c;

	if (invalidState (comp, "fmi2GetDerivatives", validGet))
		return fmi2Error;
	if (invalidNumber(comp, "fmi2GetDerivatives", "nx", nx, NDIFF))
		return fmi2Error;
	if (nullPointer  (comp, "fmi2GetDerivatives", "derivatives[]", derivatives))
		return fmi2Error;

#if NDIFF>0
	if (comp->state==modelInitialized && !comp->synced) {
		SolverUpdate(&(comp->S),0,0);
		if(errorOccured>0) {
			setVidError(comp,NULL);
			if (comp->fptr) {
				writeErrorToFile(comp->fptr,NULL);
				comp->fptr = NULL;
			}
			errorOccured=0;
			logMessage(comp, "fmi2GetDerivatives", "error", fmi2Discard);
			return fmi2Discard;
		}
		else if(errorOccured<0) {
			logMessage(comp, "fmi2GetDerivatives", "warning", fmi2Warning);
			errorOccured=0;
		}
		comp->synced = fmi2True;
		comp->jsynced = fmi2False;
	}
	for (i=0; i<(int)nx; i++) {
		if( nomfac )
			derivatives[i] = comp->S.w[vrDers[i]]/nomfac[i];
		else
			derivatives[i] = comp->S.w[vrDers[i]];
		if (comp->loggingOn)
			compLog(compEnv, comp->instanceName, fmi2OK, "log",
					"fmi2GetDerivatives: #r%d# = %.16g",	vrDers[i], derivatives[i]);
	}
#endif
	return fmi2OK;
}
/* END: fmi2GetDerivatives */
/*****************************************************************************/

/*****************************************************************************/
/* BEGIN: fmi2GetEventIndicators */
fmi2Status fmi2GetEventIndicators(	fmi2Component	c,
									fmi2Real		eventIndicators[],
									size_t			ni) {
#if NEVT>0
	int i;
	M_INT *modes;
	fmi2Status sts;
#endif
	ModelInstance* comp = (ModelInstance *)c;

	if (invalidState (comp, "fmi2GetEventIndicators", validGet))
		return fmi2Error;
	if (invalidNumber(comp, "fmi2GetEventIndicators", "ni", ni, NEVT))
		return fmi2Error;

#if NEVT>0
	sts = syncModel(c,"fmi2GetEventIndicators");
	if ( sts!=fmi2OK ) return(sts);
	eev(comp->S.w[0],&(comp->S.w[1]),&(comp->S.w[1]),eventIndicators);
	modes=comp->S.iw;
	ComputeEventIndicators(eventIndicators,&(comp->S.w[1]),modes,
		&modes[3*NEVT],&modes[2*NEVT],&modes[4*NEVT]);
	for (i=0; i<(int)ni; i++) {
		if (comp->loggingOn)
			compLog(compEnv, comp->instanceName, fmi2OK, "log",
					"fmi2GetEventIndicators: z%d = %.16g",
					i, eventIndicators[i]);
	}
#else
	UNUSED(eventIndicators);
#endif
	return fmi2OK;
}
/* END: fmi2GetEventIndicators */
/*****************************************************************************/

/*****************************************************************************/
/* BEGIN: fmi2GetContinuousStates */
fmi2Status fmi2GetContinuousStates(	fmi2Component	c,
									fmi2Real		states[],
									size_t			nx) {
#if NDIFF>0
	int i;
	fmi2Status sts;
#endif
	ModelInstance* comp = (ModelInstance *)c;

	if (invalidState (comp, "fmi2GetContinuousStates", validGet))
		return fmi2Error;
	if (invalidNumber(comp, "fmi2GetContinuousStates", "nx", nx, NDIFF))
		return fmi2Error;
#if NDIFF>0
	if (nullPointer  (comp, "fmi2GetContinuousStates", "states[]", states))
		return fmi2Error;

	sts = syncModel(c,"fmi2GetContinuousStates");
	if ( sts!=fmi2OK ) return(sts);
	for (i=0; i<(int)nx; i++) {
		if( nomfac )
			states[i] = comp->S.w[vrStates[i]]/nomfac[i];
		else
			states[i] = comp->S.w[vrStates[i]];
		if (comp->loggingOn)
			compLog(compEnv, comp->instanceName, fmi2OK, "log",
					"fmi2GetContinuousStates: #r%u# = %.16g", vrStates[i], states[i]);
	}
#endif
	return fmi2OK;
}
/* END: fmi2GetContinuousStates */
/*****************************************************************************/

/*****************************************************************************/
/* BEGIN: fmi2GetNominalsOfContinuousStates */
fmi2Status fmi2GetNominalsOfContinuousStates(fmi2Component	c,
											fmi2Real		x_nominal[],
											size_t			nx) {
	ModelInstance* comp = (ModelInstance *)c;
	int i;

	if (invalidState (comp, "fmi2GetNominalsOfContinuousStates", validGet))
		return fmi2Error;
	if (invalidNumber(comp, "fmi2GetNominalsOfContinuousStates", "nx", nx, NDIFF))
		return fmi2Error;
	if (nullPointer  (comp, "fmi2GetNominalsOfContinuousStates", "x_nominal[]", x_nominal))
		return fmi2Error;

	if (comp->loggingOn)
		compLog(compEnv, comp->instanceName, fmi2OK, "log",
				"fmi2GetNominalsOfContinuousStates: x_nominal[0..%d] = 1.0", nx-1);
	if( nomfac )
		for (i=0; i<(int)nx; i++) x_nominal[i] = 1.0/nomfac[i-1];
	else
		for (i=0; i<(int)nx; i++) x_nominal[i] = 1.0;

	return fmi2OK;
}
/* END: fmi2GetNominalsOfContinuousStates */
/*****************************************************************************/

#endif

/*****************************************************************************/
/* Special purpose data communication functions */

typedef fmi2Status getMapleSimVideoDataLengthTYPE(fmi2Component, fmi2Integer *);
#define getMapleSimVideoDataLength fmi2FullName(getMapleSimVideoDataLength)
FMI2_Export getMapleSimVideoDataLengthTYPE getMapleSimVideoDataLength;

fmi2Status getMapleSimVideoDataLength(fmi2Component c, fmi2Integer *len)
{
	ModelInstance* comp = (ModelInstance *)c;

	if(comp->vidsts==0) {
		*len=0;
		return(fmi2Warning);
	}
	else if(comp->vidsts==1)
		*len=2+NPAR;
	else if(comp->vidsts==2)
		*len=NEQ+1;
	else if(comp->vidsts==-1)
		*len=2+strlen(comp->viderror)/8;
	else {
		*len=0;
		return(fmi2Error);
	}
	return(fmi2OK);
}

typedef fmi2Status getMapleSimVideoDataTYPE(fmi2Component, fmi2Real *);
#define getMapleSimVideoData fmi2FullName(getMapleSimVideoData)
FMI2_Export getMapleSimVideoDataTYPE getMapleSimVideoData;

fmi2Status getMapleSimVideoData(fmi2Component c, fmi2Real *data)
{
	ModelInstance* comp = (ModelInstance *)c;

	if(comp->vidsts==0)
		return(fmi2Error);
	else if(comp->vidsts==1) {
		data[0]=nData[0];
		data[1]=nData[1];
		memcpy(&data[2],&comp->S.w[NEQ+1],NPAR*sizeof(fmi2Real));
	}
	else if(comp->vidsts==2)
		memcpy(data,comp->S.w,(NEQ+1)*sizeof(fmi2Real));
	else if(comp->vidsts==-1) {
		data[0]=-1e10;
		memcpy(&data[1],comp->viderror,strlen(comp->viderror)+1);
	}
	else
		return(fmi2Error);
	comp->vidsts=0;
	return(fmi2OK);
}

